!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
!2345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789012345678901234567890123456789
!        1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Defines input and global variables.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module constants
  implicit none
  REAL, parameter :: zero=0.0, one=1.0, two=2.0, three=3.0, four=4.0, five=5.0, six=6.0, seven=7.0, eight=8.0, nine=9.0, ten=10.0
  REAL, parameter :: eleven=11.0, twelve=12.0
  REAL, parameter :: quarter=one/four, third=one/three , half=one/two
  REAL, parameter :: pi2=6.28318530717958623, pi=pi2/two, mu0=2.0E-07*pi2
  REAL, parameter :: goldmean=1.618033988749895 ! golden mean = ( one + sqrt(five) ) / two ;
end module constants

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module numerical
  implicit none
  INTEGER :: largestint
  REAL    :: machprec, vsmall, small, sqrtmachprec ! this is assigned below in readin via a call to NAG routine;
end module numerical

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module fileunits
  implicit none
  INTEGER :: ounit          =  0
  INTEGER :: inunit         = 10
  INTEGER :: dataunit       = 11
  INTEGER :: poincareunit   = 12
  INTEGER :: hessianunit    = 13
  INTEGER :: qfmsunit       = 14
  INTEGER :: transformunit  = 15
  INTEGER :: periodicunit   = 16
  INTEGER :: irrationunit   = 17
  INTEGER :: iterationunit  = 18
  INTEGER :: derivativeunit = 19
  INTEGER :: harmonicsunit  = 18
end module fileunits

module cputiming
! CPUVARIABLE ! this is expanded by Makefile; do not remove;
  REAL :: Treadin=0.0
  REAL :: Twritin=0.0
end module cputiming

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module typedefns
  
  type subgrid
     REAL,    allocatable :: s(:)
     INTEGER, allocatable :: i(:)
  end type subgrid

  type submatrix
     REAL,    allocatable :: mnllRZ(:,:,:)
  end type submatrix

end module typedefns

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module inputlist !latex \heading{inputlist}
  implicit none

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The input file, \verb+ext.spec+, where \verb+ext+ is given as command line input contains the following namelists and interface geometry.
  CHARACTER          :: ext*100 

  INTEGER, parameter :: MNvol = 100 ! the maximum number of volumes allowed;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/physicslist/; note that all variables in namelist need to be broadcasted in readin;

  INTEGER :: Nvol           =  1
  INTEGER :: Nfp            =  1
  INTEGER :: Mpol           =  1
  INTEGER :: Ntor           =  0
  REAL    :: pscale         =  0.0
  REAL    :: beta           =  0.0
  REAL    :: tflux(0:MNvol)
  REAL    ::  pres(1:MNvol)
  REAL    ::    mu(1:MNvol)
  REAL    :: pflux(0:MNvol)
  INTEGER :: pl(0:MNvol)    =  0
  INTEGER :: ql(0:MNvol)    =  1
  INTEGER :: pr(0:MNvol)    =  0
  INTEGER :: qr(0:MNvol)    =  1
  INTEGER :: Ni(MNvol)      =  2
  INTEGER :: Lsetmupf       =  1
  REAL    :: mupftol        =  1.0e-10
  INTEGER :: mupfits        = -1

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/numericslist/; note that all variables in namelist need to be broadcasted in readin;

  INTEGER :: Ndiscrete      =  2
  INTEGER :: Ls             =  2
  INTEGER :: Icoords        =  1
  INTEGER :: Nofe           =  2
  INTEGER :: Nquad          =  6
  INTEGER :: iMpol          = -1
  INTEGER :: iNtor          = -1
  INTEGER :: Iswmin         =  1
  LOGICAL :: Lsymagl        = .false.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/linearlist/; note that all variables in namelist need to be broadcasted in readin;

  LOGICAL :: Ldense    = .true.
  LOGICAL :: Lsparse   = .false.
  LOGICAL :: Lposdef   = .true.
  REAL    :: sparsetol = -1.0
  INTEGER :: sparseits = -1
  INTEGER :: sparsepc  =  2
  REAL    :: ssoromega =  1.0

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/nonlinearlist/; note that all variables in namelist need to be broadcasted in readin;

  LOGICAL   :: Lc05ndf   = .false.
  LOGICAL   :: Lc05pdf   = .false.
  REAL      :: forcetol  = 1.0e-09
  REAL      :: forceerr  =  0.0
  REAL      :: factor    = 1.0e-02
  INTEGER   :: Hsetmupf  =  0
  INTEGER   :: Iusesg    =  0
  INTEGER   :: pwidth    =  6
  INTEGER   :: qwidth    =  6
  INTEGER   :: iextrap   = -1
  INTEGER   :: ifinited  =  0
  LOGICAL   :: LuseDM    = .false.
  CHARACTER :: DMext*2   = "aa"

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/diagnosticslist/; note that all variables in namelist need to be broadcasted in readin;

  REAL    :: odetol         =   1.0e-07
  INTEGER :: nPpts          = 200
  INTEGER :: nPtrj(1:MNvol) =  -1
  INTEGER :: Mpqits         =  10
  INTEGER :: p1(1:MNvol)    =   0
  INTEGER :: q1(1:MNvol)    =   0
  INTEGER :: p2(1:MNvol)    =   0
  INTEGER :: q2(1:MNvol)    =   0
  INTEGER :: npq(1:MNvol)   =   0
  INTEGER :: Mirrits        =   0
  INTEGER :: irrMpol        =  50
  INTEGER :: irrNtor        =  25
  REAL    :: irrsvdcut      =   1.0e-12
  REAL    :: irrtol         =   1.0e-08
  LOGICAL :: Lwrpj          =  .false.
  INTEGER :: Nghd           =   0
  INTEGER :: Nadi           =   0
  INTEGER :: Nadj           =   0
  LOGICAL :: Lcompare       =  .false.
  LOGICAL :: Levalues       =  .false.
  LOGICAL :: Levectors      =  .false.
  LOGICAL :: Lcurlerr       =  .false.
  LOGICAL :: Ltiming        =  .false.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! the following variables constitute the namelist/screenlist/; note that all variables in namelist need to be broadcasted in readin;
  
! DSCREENLIST ! define screenlist; this is expanded by Makefile; do not remove; each file compiled by Makefile has its own write flag;
  LOGICAL :: Wreadin = .false.
  LOGICAL :: Wwritin = .false.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \vspace{1.0cm} \hrule \vspace{0.1cm}
!latex \verb+namelist/physicslist/+ ! controls numerical resolution of Beltrami fields and interface geometry; \begin{itemize}

  namelist/physicslist/&
 Nvol        ,& !latex \item \verb+Nvol=1 : integer+ : number of annular volumes;
 Nfp         ,& !latex \item \verb+Nfp=1 : integer+ : field periodicity;
 Mpol        ,& !latex \item \verb+Mpol=1 : integer+ : poloidal resolution; constraint \verb+Mpol>0+;
 Ntor        ,& !latex \item \verb+Ntor=0 : integer+ : toroidal resolution;
 pscale      ,& !latex \item \verb+pscale=0.0 : real+ : pressure scale factor;
 beta        ,& !latex \item \verb+beta=0.0 : real+ : on exit, plasma beta;
 tflux       ,& !latex \item \verb+tflux : real(0:MNvol)+ : toroidal flux in each volume;
 pres        ,& !latex \item \verb+pres : real(1:MNvol)+ : pressure in each volume;
 mu          ,& !latex \item \verb+mu : real(1:MNvol)+ : helicity-multiplier, $\mu$, in each volume;
 pflux       ,& !latex \item \verb+pflux : real(0:MNvol)+ : poloidal flux, $\psi_p$, in each volume;
 pl          ,& !latex \item \verb+pl : integer(0:MNvol)+ : interface transform $(p_l+\gamma p_r)/(q_l+\gamma q_r)$;
 ql          ,& !latex \item \verb+ql : integer(0:MNvol)+ : interface transform $(p_l+\gamma p_r)/(q_l+\gamma q_r)$;
 pr          ,& !latex \item \verb+pr : integer(0:MNvol)+ : interface transform $(p_l+\gamma p_r)/(q_l+\gamma q_r)$;
 qr          ,& !latex \item \verb+qr : integer(0:MNvol)+ : interface transform $(p_l+\gamma p_r)/(q_l+\gamma q_r)$;
 Ni          ,& !latex \item \verb+Ni=2 : integer(MNvol)+ : sub-grid resolution in each volume;
 Lsetmupf    ,& !latex \item \verb+Lsetmupf=1 : integer+ : if \verb+Lsetmupf=1+, then $\mu$ and $\psi_p$, 
                !latex in each annulus are adjusted iteratively to satisfy the interface transform contraints;
                !latex see \verb+ma02aa+; 
 mupftol     ,& !latex \item \verb+mupftol=1.0e-06 : real+ : accuracy to which $\mu$ and $\psi_p$ are required;
                !latex only relevant if \verb+Lsetmupf=1+; !latex see \verb+ma02aa+; 
 mupfits        !latex \item \verb+mupfits=-1 : integer+ : maximum allowed iterations in solving for $\mu$ and $\psi_p$;
                !latex if \verb+mupfits<0+ then there is no limit; only relevant if \verb+Lsetmupf=1+; see \verb+mp00aa+, \verb+ma02aa+;
                !latex \end{itemize}
                !latex Comments:
                !latex If \verb+Lsetmupf=1+, then \verb+mu+$\equiv\mu$ and \verb+pflux+$\equiv\psi_p$ will be adjusted to satisfy interface transform constraint.
                !latex In this case, $\mu$ and $\psi_p$ should be suitable `initial guesses'.
                !latex \vspace{0.1cm} \hrule \vspace{0.5cm}


!latex \vspace{1.0cm} \hrule \vspace{0.1cm}
!latex \verb+namelist/numericslist/+ ! controls numerical resolution of Beltrami fields and interface geometry; \begin{itemize}

  namelist/numericslist/&
 Ndiscrete   ,& !latex \item \verb+Ndiscrete=2 : integer+ : discrete resolution; constraint \verb+Ndiscrete>0+; \\
 Ls          ,& !latex \item \verb+Ls=2 : integer+ : selects radial coordinate;
                !latex if \verb+Ls=0+, the radial coordinate is simply the surface index;
                !latex if \verb+Ls=1+, the radial coordiante is the toroidal flux, $\psi_t$;
                !latex if \verb+Ls=2+, the radial coordinate is $\sqrt \psi_t$;
 Icoords     ,& !latex \item \verb+Icoords=1 : integer+ : controls order of $R_{mn},Z_{mn}$ interpolation;
                !latex if \verb+Icoords=0+, a linear interpolation of $R_{mn},Z_{mn}$ is employed;
                !latex if \verb+Icoords=1+, a cubic (NAG) interpolation of $R_{mn},Z_{mn}$ is employed;
                !latex if \verb+Icoords=2+, a cubic (homemade) interpolation of $R_{mn},Z_{mn}$ is employed;
 Nofe        ,& !latex \item \verb+Nofe=2 : integer+ : controls order of finite-element basis functions used to discretize vector potential;
                !latex if \verb+Nofe=0+, linear    basis functions are used;
                !latex if \verb+Nofe=1+, cubic     basis functions are used;
                !latex if \verb+Nofe=2+, quintic   basis functions are used;
                !latex if \verb+Nofe=3+, septemtic basis functions are used;
 Nquad       ,& !latex \item \verb+Nquad=6 : integer+ : the resolution of the Gaussian quadrature;
                !latex constraint \verb+Nquad.gt.0+; see \verb+global/readin+; 
 iMpol       ,& !latex \item \verb+iMpol=-1 : integer+ : poloidal resolution of transformation to straight-field line coordinates on interfaces;
                !latex if \verb+iMpol.lt.0+, then \verb+iMpol = 4 * Mpol * abs(iMpol)+;
 iNtor       ,& !latex \item \verb+iNtor=-1 : integer+ : toroidal resolution of transformation to straight-field line coordinates on interfaces;
                !latex if \verb+iNtor.lt.0+, then \verb+iNtor = 4 * Ntor * abs(iNtor)+;
 Iswmin      ,& !latex \item \verb+Iswmin=1 : integer+ : construct spectrally condensed angle as a pre-processing step;
                !latex if \verb+Iswmin=1+, the Fourier representation of all interfaces (incl. outer boundary) is converted to spectrally condensed representation;
                !latex if \verb+Iswmin=2+, the spectrally condensed representation of the outer boundary is written to the restart file, \verb+ext.end+, on completion,
                !latex otherwise the original Fourier representation is written to \verb+ext.end+;
                !latex if \verb+Iswmin=4+, program execution is terminated after the spectrally condensed angle has been constructed; for debugging;
                !latex counted `bit-wise' and converted to the internal logical array \verb+lswmin(1:3)+; see \verb+spec,sw00ac+;
 Lsymagl        !latex \item \verb+Lsymagl=F : logical+ : use symmetry to reduce;

!latex \end{itemize}

!latex Comments:
!latex The metric elements are constructed at enhanced resolution, \verb+lMpol=3 Mpol+; so \verb+Ndiscrete+ should be set carefully;
!latex Setting \verb+Icoords.eq.0+ seems to give problems, and this needs to be investigated:
!latex is the Jacobian required to be continuous across the interfaces for force balance to be solved?
!latex \vspace{0.1cm} \hrule \vspace{0.5cm}


!latex \vspace{0.5cm} \hrule \vspace{0.1cm}
!latex \verb+namelist/linearlist/+ ! controls the method by which the Beltrami linear system is to be solved; \begin{itemize}

  namelist/linearlist/&
 Ldense   ,&    !latex \item\verb+Ldense=T : logical+ : use dense (full-matrix) representation to solve the Beltrami linear system; 
                !latex the `Beltrami-matrix', \verb+MB+, and `Beltrami-rhs', \verb+MR+, are allocated in \verb+ma02aa+ and constructed in \verb+ma01aa+; 
                !latex the linear system is solved in \verb+mp00aa+ using either \verb+F04ASF+ if \verb+Lposdef.eq.T+ or \verb+F04ATF+ otherwise;
 Lsparse  ,&    !latex \item\verb+Lsparse=F : logical+ : use sparse-matrix representation to solve the Beltrami linear system;
                !latex the `Beltrami-matrix', \verb+SCSF+, with \verb+irow+ and \verb+icol+, and the `Beltrami-rhs', \verb+MR+, 
                !latex are allocated in \verb+ma02aa+ and constructed in \verb+ma01aa+;
                !latex the linear system is solved in \verb+mp00aa+ using \verb+F11JEF+;
 Lposdef  ,&    !latex \item\verb+Lposdef=T : integer+ : assumes Beltrami linear system is positive definite;
                !latex relevant for both \verb+Ldense.eq.T+ or \verb+Lsparse.eq.T+; see \verb+mp00aa+;
 sparsetol,&    !latex \item\verb+sparsetol=-1.0 : real+ : required tolerance in iterative solution of Beltrami linear system;
                !latex passed to \verb+F11JEF+; relevant only if \verb+Lsparse.eq.T+;
                !latex if \verb+sparsetol < 0.0+, then \verb+sparsetol+$\rightarrow \epsilon$ where $\epsilon$ is machine precision;
                !latex constraint \verb+sparsetol.lt.1.0+; see \verb+mp00aa+;
 sparseits,&    !latex \item\verb+sparseits=-1 : integer+ : max. iterations in iterative solution of Beltrami linear system;
                !latex passed to \verb+F11JEF+; relevant only if \verb+Lsparse.eq.T+;
                !latex if \verb+sparseits < 0+, then \verb+sparseits+$\rightarrow N$ where $N$ is the size of the matrix; constraint \verb+sparseits.ne.0+; see \verb+mp00aa+;
 sparsepc ,&    !latex \item\verb+sparsepc=2 : integer+ : selection of preconditioner used in iterative solution of Beltrami linear system;
                !latex passed to \verb+F11JEF+; relevant only if \verb+Lsparse.eq.T+;
                !latex constraint \verb+sparsepc=0+ (for no preconditioning),
                !latex            \verb+sparsepc=1+ (for Jacobi preconditioning) or
                !latex            \verb+sparsepc=2+ (for symmetric successive over relaxation, SSOR); see \verb+mp00aa+;
 ssoromega      !latex \item\verb+ssoromega=1.0 : real+ : relaxation parameter, $\omega$, used in SSOR method;
                !latex passed to \verb+F11JEF+; relevant only if \verb+Lsparse.eq.T+ {\em and} \verb+sparsepc=2+; constraint $0.0\le\omega\le 2.0$; see \verb+mp00aa+;

!latex \end{itemize}

!latex Comments:
!latex Must choose \verb+Ldense.eq.T+ or \verb+Lsparse.eq.T+, or both. If both are selected the solution will be compared.
!latex Using the sparse representation should require less memory and can potentially be faster if a good initial guess is provided.
!latex \vspace{0.1cm} \hrule \vspace{0.5cm}


!latex \vspace{0.5cm} \hrule \vspace{0.1cm}
!latex \verb+ namelist/nonlinearlist/+ ! controls finding zero of force balance; \begin{itemize}

  namelist/nonlinearlist/& 
 Lc05ndf     ,& !latex \item \verb+Lc05ndf=F : logical+ : use NAG \verb+C05NDF+ for finding ${\bf F}({\bf x})=0$, where ${\bf F}$ is calculated by \verb+fc00aa+;
                !latex this routine uses function values only (i.e. the derivative matrix is constructed internally);
                !latex see \verb+jk01aa+ which is called from \verb+spec+;
 Lc05pdf     ,& !latex \item \verb+Lc05pdf=T : logical+ : use NAG \verb+C05PDF+ for finding ${\bf F}({\bf x})=0$, where ${\bf F}$ is calculated by \verb+fc00aa+;
                !latex this routine requires a user supplied derivative matrix, $\nabla {\bf F}$, which is constructed (in parallel) by \verb+fc00aa+;
                !latex see \verb+jk02aa+ which is called from \verb+spec+;
 forcetol    ,& !latex \item \verb+forcetol=1.0e-09 : real+ : tolerance in position used by \verb+C05NDF+ and \verb+C05PDF+;
 forceerr    ,& !latex \item \verb+forceerr=0.0 : real+ : on exit, force balance error;
                !latex constraint \verb+forcetol>0.0+;
 factor      ,& !latex \item \verb+factor=1.0e-02 : real+ : factor used to control initial step size in \verb+C05NDF+ and \verb+C05PDF+;
                !latex constraint \verb+factor>0.0+;
 Hsetmupf    ,& !latex \item \verb+Hsetmupf=0 : logical+ : if true then will allow $\mu$ and $\psi_p$ to vary in computing derivative matrix, $\nabla {\bf F}$;
                !latex only relevant if \verb+Lc05pdf=T+;
                !latex see \verb+fc00aa+;
 Iusesg      ,& !latex \item \verb+Iusesg=0 : integer+ : power of Jacobian factor in force-balance; then \mbox{$F_{m,n}\equiv([[p+B^2/2]]\sqrt g^i)_{m,n}$};
                !latex see \verb+cb00aa+;
 pwidth      ,& !latex \item \verb+pwidth=6 : integer+ : spectral width/length exponent;
                !latex the angle freedom is exploited to minimize $\sum_{m,n}m^p(R_{m,n}^2+Z_{m,n}^2)$; see \verb+sw02aa+;
 qwidth      ,& !latex \item \verb+qwidth=6 : integer+ : spectral width/length exponent;
                !latex the angle freedom is exploited to minimize $\sum_{m,n}m^p(R_{m,n}^2+Z_{m,n}^2)$; see \verb+sw02aa+;
 iextrap     ,& !latex \item \verb+iextrap=-1 : integer+ : order of extrapolation of axis;
                !latex constraint \verb+iextrap.ge.1+ and \verb+iextrap.le.Nvol+; if \verb+iextrap.lt.0+ then \verb+iextrap+$\rightarrow$\verb+Nvol+; see \verb+ex00aa+;
 ifinited    ,& !latex \item \verb+ifinited=0 : integer+ : controls magnitude of step-size, $\Delta$, in finite-difference approximation to derivative matrix;
                !latex only required if \verb+Lc05pdf=T+;
 LuseDM      ,& !latex \item \verb+LsumDM=F : logical+ : will read \verb+.derivative.DMext+ to get initial derivative matrix;
 DMext          !latex \item \verb+DMext="aa" : character+ : distinguishing suffix on derivative matrix file \verb+.derivative.DMext+;

!latex \end{itemize}

!latex Comments:
!latex The `force' vector, ${\bf F}({\bf x})$, is calculated by \verb+fc00aa+.
!latex The vector ${\bf F}$ is a combination of force-imbalance harmonics, $[[p+B^2/2]]_{m,n}$ and spectral-condensation constraints,
!latex and the vector ${\bf x}$ represents the internal interface geometry harmonics.
!latex \vspace{0.1cm} \hrule \vspace{0.5cm}


!latex \vspace{0.5cm} \hrule \vspace{0.1cm}
!latex \verb+namelist/diagnosticslist/+ ! controls diagnostic and post-processor routines; \begin{itemize}

  namelist/diagnosticslist/&
 odetol     ,&  !latex \item \verb+odetol=1.0e-07 : real+ : o.d.e. integration tolerance for all field line tracing routines;
 nPpts      ,&  !latex \item \verb+nPpts=0 : integer+ : number of toroidal transits used (per trajectory) in following field lines for constructing \Poincare plots;
                !latex if \verb+nPpts<1+, no \Poincare plot is constructed;
 nPtrj      ,&  !latex \item \verb+nPtrj=-1 : integer(1:MNvol)+ : number of trajectories in each annulus following in constructing \Poincare plot;
                !latex if \verb+nPtrj(i)<0+, then \verb+nPtrj(i)=Ni(i)+, where \verb+Ni(i)+ is the grid resolution used to construct the Beltrami field in annulus $i$;
 Mpqits     ,&  !latex \item \verb+Mpqits=10 : integer+ : maximum allowed iterations in finding periodic orbits; see \verb+pq00aa,pq02aa+;
 p1         ,&  !latex \item \verb+p1=0 : integer(1:MNvol)+ : selection of periodic orbits and noble irrational surface; see \verb+pq01aa+;
 q1         ,&  !latex \item \verb+q1=0 : integer(1:MNvol)+ : selection of periodic orbits and noble irrational surface; see \verb+pq01aa+;
 p2         ,&  !latex \item \verb+p2=0 : integer(1:MNvol)+ : selection of periodic orbits and noble irrational surface; see \verb+pq01aa+;
 q2         ,&  !latex \item \verb+q2=0 : integer(1:MNvol)+ : selection of periodic orbits and noble irrational surface; see \verb+pq01aa+;
 npq        ,&  !latex \item \verb+npq=0 : integer(1:MNvol)+ : number of required additional periodic orbits as defined by Fibonacci series
                !latex beginning from \verb+p1/q1+ and \verb+p2/q2+;
 Mirrits    ,&  !latex \item \verb+Mirrits=0 : integer+ : maximum allowed iterations in finding irrational surface; if \verb+Mirrits<1+, irrational surfaces are not located;
 irrMpol    ,&  !latex \item \verb+irrMpol=50 : integer+ : poloidal resolution of irrational surface; only required if \verb+Mirrits>0+; see \verb+pq01aa,ir00aa+;
 irrNtor    ,&  !latex \item \verb+irrNtor=25 : integer+ : toroidal resolution of irrational surface; only required if \verb+Mirrits>0+; see \verb+pq01aa,ir00aa+;
 irrsvdcut  ,&  !latex \item \verb+irrsvdcut=1.0e-12 : real+ : SVD inversion singular cutoff used to locate irrational surfaces; only required if \verb+Mirrits>0+;
                !latex see \verb+ir00aa+;
 irrtol     ,&  !latex \item \verb+irrtol=1.0e-08 : real+ : irrational surface tolerance; only required if \verb+Mirrits>0+;see \verb+ir00aa+;
 Lwrpj      ,&  !latex \item \verb+Lwrpj=F : logical+ : the pressure-jump Hamiltonian input files are written;
 Nghd       ,&  !latex \item \verb+Nghd=0 : integer+ : poloidal resolution of ghost-surfaces $\equiv$ quadratic-flux minimizing surfaces;
 Nadi       ,&  !latex \item \verb+Nadi=0 : integer+ : see \verb+hr00aa+; anisotropic-diffusion;
 Nadj       ,&  !latex \item \verb+Nadj=0 : integer+ : see \verb+hr00aa+; anisotropic-diffusion;
 Lcompare   ,&  !latex \item \verb+Lcompare=F : logical+ : to compare parallel construction of $\nabla {\bf F}$ with series construction; see \verb+he01aa+;
 Levalues   ,&  !latex \item \verb+Levalues=F : logical+ : to compute eigenvalues of $\nabla {\bf F}$; see \verb+he01aa+;
 Levectors  ,&  !latex \item \verb+Levectors=F : logical+ : to compute eigenvectors (and also eigenvalues) of $\nabla {\bf F}$; see \verb+he01aa+;
 Lcurlerr   ,&  !latex \item \verb+Lcurlerr=F : logical+ : check Beltrami field error, $\nabla \times {\bf B}-\mu {\bf B}$;
                !latex see \verb+jo00aa+;
 Ltiming        !latex \item \verb+Ltiming=F : logical+ : to check timing;

!latex \end{itemize}
!latex \vspace{0.1cm} \hrule \vspace{0.5cm}

  namelist/screenlist/&
! NSCREENLIST ! namelist screenlist; this is expanded by Makefile; do not remove;
 Wreadin , &
 Wwritin
  
! note that all variables in namelist need to be broadcasted in readin;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end module inputlist

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Additional global arrays are defined in module \verb!allglobal!. These include the surface geometry and tangential fields:

module allglobal

  use constants
  use typedefns

  implicit none

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  INTEGER              :: myid, numprocs   ! mpi variables;
  REAL                 :: cpus             ! timing variables;

  REAL                 :: pi2nfp           ! pi2nfp=pi2 / nfp; assigned in readin;

  REAL                 :: pi2pi2nfpquarter ! used in me00ab; assigned in readin;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Fourier representation}

!latex \item The Fourier description of the geometry and fields is given 
!latex \be f(\s,\t,\z) = \sum_j f_j(s) \cos( m_j \t - n_j \z ), \;\;\; \mbox{\rm or} \;\;\; f(\s,\t,\z) = \sum_j f_j(s) \sin( m_j \t - n_j \z ),
!latex \ee
!latex for $j=1,$ \verb+mn+, where 
!latex \verb-mn = Ntor + 1 +  Mpol * ( 2 * Ntor + 1 )-, $m_j \equiv $\verb+im(j)+, $n_j \equiv $\verb+in(j)+.

  INTEGER              :: mn  ! total number of Fourier harmonics for coordinates/fields; calculated from Mpol,Ntor in readin;
  INTEGER, allocatable :: im(:) , in(:) ! Fourier modes; set in readin;



!latex \item Enhanced resolution is required for the metric elements, $g_{ij}/\sqrt g$, which is given by \verb+mne+, \verb+ime+., and \verb+ine+.
!latex The Fourier resolution here is determined by \verb+lMpol=2*Mpol+ and \verb+lNtor=2*Ntor+.
  INTEGER              :: mne ! enhanced resolution for metric elements;
  INTEGER, allocatable :: ime(:), ine(:)

!latex \item Enhanced resolution is required for the transformation to straight-field line angle on the interfaces, which is given by \verb+mns+, \verb+ims+., and \verb+ins+.
!latex The Fourier resolution here is determined by \verb+iMpol+ and \verb+iNtor+.
  INTEGER              :: mns ! enhanced resolution for straight field line transformation;
  INTEGER, allocatable :: ims(:), ins(:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Interface geometry}

!latex \item The Fourier harmonics, and their radial derivatives, of the interfaces are contained in \verb+Rbc(0:Nvol,0:1,1:mn)+ and \verb+Zbs(0:Nvol,0:1,1:mn)+, where
!latex \verb+Rbc(l,0,j)+, \verb+Zbs(l,0,j)+ contains the Fourier harmonics, $R_j$, $Z_j$, of the $l$-th interface.
!latex \item The radial derivatives, $\partial_s R_j$ and $\partial_s Z_j$ at the $l$-th interface are given by \verb+Rbc(l,1,j)+ and \verb+Zbs(l,1,j)+.
!latex \item Note that the coordinate axis, given by the Fourier harmonics \verb+Rbc(0,0,1:mn)+ and \verb+Zbs(0,0,1:mn)+,
!latex is set in \verb+ex00aa+ and is {\em not} considered a geometrical degree of freedom.

  REAL,    allocatable :: Rbc(:,:,:), Zbs(:,:,:) ! interface surface geometry;

!latex \item The workspace arrays, \verb+Rmn(0:2,1:mn)+ and \verb+Zmn(0:2,1:mn)+, are used to interpolate the interface geometry, and 
!latex \verb+Rmn(2,j)+ and \verb+Zmn(2,j)+ contain the second radial partial derivatives, $\partial_{ss}^2 R_j$ and $\partial_{ss}^2 Z_j$.

  REAL,    allocatable :: Rmn(:,:), Zmn(:,:)     ! for interpolating coordinates; see c01aa; Rmn(0:2,1:mn),Zmn(0:2,1:mn)

!latex The geometrical degrees of freedom is given by \verb&Ngdof=(Nvol-1)*(mn+mn-1)&.
!latex This is assuming fixed boundary, so the outermost inteface is not free to move.

  INTEGER              :: Ngdof ! geometrical degrees of freedom;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Fourier Transforms}

!latex \item The coordinate geometry and fields are mapped to/from Fourier space and real space using the NAG routine \verb+C06FUF+.
!latex \item The resolution of the real space grid is given by \verb+Nt=Ndiscrete*4*Mpol+ and \verb+Nz=Ndiscrete*4*Ntor+.
!latex \item Trigonometric information required for the FFT's is saved in \verb+trigm(1:2*Nt)+, \verb+trign(1:2*Nz)+, and \verb+trigwk(1:2*Ntz)+,
!latex where \verb+Ntz=Nt*Nz+.

  INTEGER              :: Nt, Nz, Ntz ! discrete resolution; Ntz=Nt*Nz shorthand;
  REAL                 :: soNtz ! one / sqrt (one*Ntz); shorthand;

  CHARACTER            :: isr ! required for C06FUF;
  REAL   , allocatable :: trigm(:), trign(:), trigwk(:) ! these are set in readin and contain trigonometric factors; cannot be changed;

!latex \item Various workspace arrays are allocated. 
!latex These include \verb+Rij(0:9,Ntz)+ and \verb+Zij(0:9,Ntz)+, which contain the coordinates in real space and their derivatives;
!latex \verb+sg(0:3,Ntz)+, which contains the Jacobian and its derivatives;
!latex and \verb+gij(1:6,0:3,1:Ntz)+, which contains the metric elements and their derivatives.

  REAL   , allocatable :: Rij(:,:), Zij(:,:), sg(:,:), gij(:,:,:), glmn(:,:) ! dummy arrays;

  REAL,    allocatable :: ofmn(:), efmn(:), sfmn(:), cfmn(:) ! Fourier harmonics; dummy workspace;
  REAL,    allocatable :: ijreal(:), ijimag(:), jireal(:), jiimag(:) ! real grid; dummy workspace;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Metric information}
!latex \item The averaged metric coefficients are 
!latex \verb+agss(1:njk)+, \verb+agst(1:njk)+, \verb+agsz(1:njk)+, \verb+agtt(1:njk)+, \verb+agtz(1:njk)+, \verb+agzz(1:njk)+, and \verb+agoo(1:njk)+.
!latex These are described (and calculated) in \verb+me00ab+, and used in \verb+ma00aa+.

  REAL,    allocatable :: agss(:), agst(:), agsz(:), agtt(:), agtz(:), agzz(:), agoo(:) 

! matrix elements; allocated in al00aa; allocated/deallocated in ma00ab/ma00ac; computed in ma00aa; used in ma01aa;
  type(subgrid), allocatable :: igss(:,:,:,:,:), igst(:,:,:,:,:), igsz(:,:,:,:,:), igtt(:,:,:,:,:), igtz(:,:,:,:,:), igzz(:,:,:,:,:), igoo(:,:,:,:,:) ! metric integrals;

  type(subgrid), allocatable :: sgss(:,:,:,:,:,:), sgst(:,:,:,:,:,:), sgsz(:,:,:,:,:,:), sgtt(:,:,:,:,:,:), sgtz(:,:,:,:,:,:), sgzz(:,:,:,:,:,:), sgoo(:,:,:,:,:,:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  REAL   , allocatable :: felr(:,:,:,:) ! left & right finite element functions on radial sub-sub-grid; assigned in fe00aa;
  REAL   , allocatable :: lelr(:,:,:,:) ! left & right finite element functions on radial sub-sub-grid; assigned in fe00aa; local to ll-th volume;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \heading{Enclosed fluxes}
!latex \item The input variables are the toroidal and poloidal fluxes, given in \verb+tflux(0:Nvol)+ and \verb+pflux(0:Nvol)+.
!latex \item However, the Beltrami fields in each volume depend only on the enclosed fluxes, \verb+dtflux(1:Nvol)+ and \verb+dpflux(1:Nvol)+,
!latex which are the independent degrees of freedom required to satisfy the rotational transform constraints, see \verb+ma02aa+.

  REAL,    allocatable :: dtflux(:), dpflux(:) ! \delta \psi_{toroidal} and \delta \psi_{poloidal} in each annulus;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  type(subgrid), allocatable :: At(:,:,:), Az(:,:,:) ! covariant components of vector potential; description below;

  INTEGER, allocatable :: NBdof(:) ! degrees of freedom in Beltrami fields in each annulus;
  REAL   , allocatable :: MB(:,:), MR(:) ! linear matrix in each volume and driving rhs; constructed in ma01af;
  REAL   , allocatable :: SCSF(:) ! sparse representation of Beltrami matrix;
  INTEGER, allocatable :: irow(:),icol(:) ! irow,icol identify elements in sparse matrix storage;

  REAL,    allocatable :: Atmn(:,:),Azmn(:,:) ! interpolated Fourier harmonics (and radial derivatives) of vector potential; calculated by sa00aa;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Transformation to straight-field-line angle}
!latex \item Given the Beltrami fields in any volume, the rotational-transform on the adjacent interfaces 
!latex may be determined by constructing the straight-field line angle on the interfaces.
!latex \item This is performed in \verb+tr00ab+.
!latex \item The angle transformation is stored in the array \verb+sflangle(1:Nvol,0:1,1:mns)+, 
!latex 
!latex where \verb+sflangle(l,0,1:mn)+ and \verb+sflangle(l,1,1:mn)+ are the straight-field line angle transformations on the inner and outer interfaces of the $l$-th volume.
!latex \item This is written to the file \verb+.ext.lambda+ for diagnostics.

  REAL,    allocatable :: sflangle(:,:,:)

!latex \item The rotational-transform on the inner and outer interfaces of each volume is stored in \verb+sfliota(1:Nvol,0:1)+. 
!latex This is assigned values in \verb+mp00aa+ after calling \verb+tr00ab+.

  REAL   , allocatable :: sfliota(:,:) ! measured rotational transform on inner/outer interfaces for each volume;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Radial interpolation, radial sub-grid}
!latex \item The coordinates are adapted to the interface geometry by interpolating the interface Fourier harmonics, 
!latex typically using the NAG routines \verb+E01BEF+ and \verb+E01BGF+; 
!latex see \verb+ih00aa+ for details.
!latex \item The interface radial coordinate is given by \verb+iss(0:Nvol)+, which is set in \verb+readin+, and is used by \verb+co00aa+, \verb+co01aa+, and \verb+ih00aa+.

!latex The radial coordinate is a linear interpolation of the interface radial coordinate, which may be:
!latex \begin{enumerate}
!latex \item \verb+Ls=0+ : $s \equiv$ interface label; 
!latex \item \verb+Ls=1+ : $s \equiv$ toroidal flux, $\psi_t$; 
!latex \item \verb+Ls=2+ : $s \equiv$ the square root of toroidal flux, $\sqrt \psi_t$.
!latex \end{enumerate}
!latex Note that the regularity conditions imposed on the vector potential near the coordinate origin, see \verb+ma01af+, 
!latex assume that the radial coordinate is similar to the polar coordinate, $r$.
!latex Given that the toroidal flux is proportional to $r^2$, e.g. $\psi_t \approx B^\z r^2/2$ where $B^\z$ is the toroidal field, this requires $s \equiv \sqrt \psi_t$.
!latex \item The radial coordinate is normalized, $s\in[0,1]$.

  REAL,    allocatable :: iss(:) ! interpolation independent coordinate;

!latex \item The radial sub-grid is given in \verb+ss(1:Nvol)%s(0:Ni)+, where \verb+Ni+ is the resolution of the radial sub-grid which is volume dependent.
!latex It is convenient to define the global variable \verb+rho=ss(1)%s(1)+ for treating the coordinate singularity.

  type(subgrid), allocatable :: ss(:) ! ss(ll)%s(ii) is the radial location of the ii-th sub-grid in the ll-th volume;
 !REAL                       :: rho

 !LOGICAL :: Lrho = .true. ! for debugging; to be deleted;

!latex \item The array \verb&dss(1:Nvol,-2:Nofe+Nofe)& contains powers of the radial sub-grid size, so that \verb+dss(l,n)+ $\equiv h^n$,
!latex where \mbox{$h\equiv (s_{l}-s_{l-1})/N$}.

  REAL,    allocatable :: dss(:,:) ! radial sub-grid in the ll-th volume; and powers;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \heading{Spectral width constraints}
!latex \item In addition to matching force balance across the interface, the Fourier harmonics of the interfaces are adjusted to minimize the spectral width,
!latex defined in \verb+sw02aa+.
!latex \item The spectral width constraints (in real space) are calculated in \verb+sw02aa+ and saved in \verb+swI(1:Ntz)+, and is Fourier decomposed in \verb+cb02aa+.

  REAL,    allocatable :: swI(:) ! spectral width constraint;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Construction of `force'}
!latex \item The force vector is comprised of \verb+Bomn+ and \verb+Iomn+.

  REAL,    allocatable :: Bomn(:,:,:), Iomn(:,:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Parallel construction of derivative matrix}
!latex \item The derivatives of force balance, $[[p+B^2/2]]$, and the spectral constraints (see \verb+sw02aa+), with respect to the interface geometry
!latex is constructed in parallel by \verb+fc01aa+.

!latex \item The derivatives are constructed using finite differences, 
!latex i.e. $\partial {\bf F} / \partial x_i \approx \left[{\bf F}(\dots, x_i+\Delta, \dots)-{\bf F}(\dots, x_i, \dots)\right]/\Delta$, where $\Delta \equiv$ \verb+dfd+
!latex and depends on \verb+ifinited+.
!latex If \verb+ifinited.lt.0+ then $\Delta=$\verb+10**(ifinited)+, otherwise $\Delta=\sqrt \epsilon$, where $\epsilon$ is the machine precision;

  REAL                 :: dfd ! for finite difference estimate of derivatives;

!latex \item The original geometry is saved in \verb+oRbc(0:Nvol,1:mn)+ and \verb+oZbs(0:Nvol,1:mn)+.
!latex This is required when the interface geometry is deformed to construct derivative matrix.

  REAL,    allocatable :: oRbc(:,:), oZbs(:,:) !

!latex \item Force balance across the $l$-th interface depends on the fields in the adjacent interfaces.
!latex Except for the extrapolation method used to obtain the geometry of the innermost interface, the `Hessian' matrix is block-tridiagonal.
!latex Ultimately, hopefully, the Beltrami field in the innermost volume will be calculated directly, and the \verb+RZl(1:Nvol,0:1)+ array will become redundant.

  INTEGER, allocatable :: RZl(:,:) ! indicates interface dependence;

  REAL,    allocatable :: Bdmn(:,:), Idmn(:), mBomn(:), mIomn(:)

  type(submatrix), allocatable :: dBd(:,:)     ! derivative of pressure-imbalance harmonics;
  REAL           , allocatable :: dIdRZ(:,:,:) ! derivative of spectral-minimization;

 !INTEGER              :: nHnz
 !REAL,    allocatable :: HH(:),pHess(:,:) ! Hessian, computed in parallel; sparse format;
  REAL,    allocatable :: pHess(:,:) ! derivative matrix, computed in parallel;
 !INTEGER, allocatable :: hrow(:),hcol(:) ! row, column of Hessian;
  
! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \heading{Trigonometric factors}
!latex \item To facilitate construction of the metric integrals, various trigonometric identities are exploited.
!latex \item The required information is saved in
!latex
!latex \verb+ijk(1:mn,1:mn)+

  INTEGER, allocatable :: ijk(:,:) ! symmetry identification;

!latex \item Trigonometric factors used in the calculation of $\braket{s_j}{\bar g_{ss}}{s_k}$ etc. are pre-computed and stored in \verb+trigfac(1:4,1:mne,1:mn*mn)+,
!latex where \verb+mne+ is the enhanced Fourier resolution used to represent the metric quantities $g_{ij}/\sqrt g$.
!latex \item If symmetry with respect to $j$, $k$ is to be exploited, i.e. \verb+if(Lsymagl)+, then the trigonometric factors are stored in \verb+srigfac(1:4,1:mne,1:mn*mn)+.
!latex \item The terms are based on the triple angle expansions:
!latex \be
!latex \sin \alpha_j \cos \alpha_p \sin \alpha_k &=& \frac{1}{4} \left[
!latex -\cos(\alpha_j+\alpha_p+\alpha_k) +\cos(\alpha_j+\alpha_p-\alpha_k) -\cos(\alpha_j-\alpha_p+\alpha_k) +\cos(\alpha_j-\alpha_p-\alpha_k) 
!latex \right] \\
!latex \sin \alpha_j \sin \alpha_p \cos \alpha_k &=& \frac{1}{4} \left[
!latex -\cos(\alpha_j+\alpha_p+\alpha_k) -\cos(\alpha_j+\alpha_p-\alpha_k) +\cos(\alpha_j-\alpha_p+\alpha_k) +\cos(\alpha_j-\alpha_p-\alpha_k) 
!latex \right] \\
!latex \cos \alpha_j \cos \alpha_p \cos \alpha_k &=& \frac{1}{4} \left[
!latex +\cos(\alpha_j+\alpha_p+\alpha_k) +\cos(\alpha_j+\alpha_p-\alpha_k) +\cos(\alpha_j-\alpha_p+\alpha_k) +\cos(\alpha_j-\alpha_p-\alpha_k) 
!latex \right]
!latex \ee
!latex \item It seems that \verb+trigfac(3,:,:)+ is redundant. This is included only so that \verb+trigfac+ is consistent with \verb+srigfac+.
!latex \item The \verb+trigfac+ and \verb+srigfac+ are only used in \verb+me00ab+
!latex in calculating \verb+agl(1,)+$\equiv \braket{s_j}{\bar g_{ss}}{s_k}$ etc.
!latex \item Comment: It is not clear how much symmetry exploitation results in reduction of memory and/or time. 
!latex It is probably easier (for concise source) to eliminate the \verb+srigfac+ altogether;
!latex however, the coding has already been implemented, so this should be checked more closely.

  REAL,    allocatable :: trigfac(:,:,:) ! allocated in al00aa; used in me00ab; only if(.not.Lsymagl);
  REAL,    allocatable :: srigfac(:,:,:) ! allocated in al00aa; used in me00ab; only if(     Lsymagl);

!latex 
!latex \verb+sgl(1:9,1:mn*mn)+

  REAL,    allocatable :: sgl(:,:) ! averaged metric coefficients; function of rho; allocated in al00aa; calculated in me00ab; used in ma00aa; 

!latex \item The following are used for volume integrals:
!latex \be a_{i,j,k} &=& m_k \int\!\!\int\!\! d\theta d\zeta \cos(\alpha_i)\cos(\alpha_j)\cos(\alpha_k) , \\
!latex     b_{i,j,k} &=& m_j \int\!\!\int\!\! d\theta d\zeta \cos(\alpha_i)\sin(\alpha_j)\sin(\alpha_k) ,\ee 

!latex 
!latex \verb+aijk(1:mn,1:mn,1:mn)+, \verb+bijk(1:mn,1:mn,1:mn)+

!latex \be a_{i,j,k,l} &=& m_k \int\!\!\int\!\!\int\!\! d\theta d\zeta \cos(\alpha_i)\cos(\alpha_j)\cos(\alpha_k)\cos(\alpha_l) , \\
!latex     b_{i,j,k,l} &=& m_j \int\!\!\int\!\!\int\!\! d\theta d\zeta \cos(\alpha_i)\cos(\alpha_j)\sin(\alpha_k)\sin(\alpha_l) ,\ee 

  INTEGER, allocatable :: aijk(:,:,:), bijk(:,:,:) ! trigonometric coefficients used to calculate volume integrals;

!latex 
!latex \verb+aijkl(1:mn,1:mn,1:mn,1:mn)+, \verb+bijkl(1:mn,1:mn,1:mn,1:mn)+

  INTEGER, allocatable :: aijkl(:,:,:,:), bijkl(:,:,:,:) ! trigonometric coefficients used to calculate derivatives;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !

!latex \heading{Volume integrals}
!latex \item The free-energy is computed and saved in \verb+Fenergy(0:Ngdof)+, where $F\equiv$ \verb+Fenergy(0)+
!latex and the derivative of the free-energy with respect to the interface geometry is $\partial_i F\equiv$ \verb+Fenergy(i)+.

  REAL   , allocatable :: Fenergy(:) ! total free-energy functional

!latex \item The volume integrals $\int dv$, $\int B^2 dv$ and $\int {\bf A}\cdot{\bf B}dv$ in each volume are computed and saved in \verb+volume(0:2,1:Nvol)+.

  REAL   , allocatable :: volume(:,:) ! volume of annular regions;

! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! ! !
  
!latex \heading{Diagnostics : periodic orbits}
!latex \item Periodic orbits may be constructed. This information is contained in a \verb+periodicorbit+ structure called 
!latex
!latex \verb+pqorbit(1:Nvol,maxval(npq))+.

  type periodicorbit
     INTEGER              :: pq(2)
     REAL                 :: to, so, res
     REAL,    allocatable :: s(:), t(:), a(:)
  end type periodicorbit
  
  type(periodicorbit), allocatable :: pqorbit(:,:) ! memory of convergents and residues;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Quadratic-flux minimizing surfaces}
!latex \item Quadratic-flux minimizing surfaces may be constructed.
!latex All the information is contained in a \verb+QFmin+ structure called \verb+qfms(1:Nvol,mnpq)+.

  type QFmin
     INTEGER              :: i ! flag;
     INTEGER              :: pq(2) ! periodicity;
     REAL,    allocatable :: trvs(:,:,:) ! theta, radial, action-gradient;
  end type QFmin

  type(QFmin),allocatable :: qfms(:,:)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Diagnostics : irrational surfaces}
!latex \item Irrational, invariant flux surfaces may be constructed.
!latex The Fourier harmonics are described by \verb+irrmn+, \verb+irrim+ and \verb+irrin+.

  INTEGER              :: irrmn ! total number of Fourier harmonics for irrational surfaces; calculated from MNirr in readin;
  INTEGER, allocatable :: irrim(:), irrin(:) ! Fourier modes for irrational surfaces; set in readin;

  type irrational
     REAL              :: iota ! prescribed irrational transform
     REAL              :: Itor, Gpol
     INTEGER           :: its
     REAL              :: err
     REAL, allocatable :: sm(:), tm(:) ! radial, angle Fourier harmonics of irrational/invariant curve in toroidal coordinates;
     REAL, allocatable :: Rbc(:), Zbs(:) ! cylindrical R, Z Fourier harmonics of irrational/invariant surface in toroidal coordinates;
     REAL, allocatable :: fmn(:) ! covariant field derived from surface potential;
  end type irrational

!latex The irrational surface Fourier harmonics, etc. are contained in a \verb+irrational+ structure called \verb+irrsurf+.

  type(irrational) :: irrsurf ! Fourier harmonics etc. of irrational surfaces ! shall construct one irrational surface per annulus;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! internal global variables;

  INTEGER              :: ll ! labels volume; the major parallelization loop uses ll as the loop index;

  INTEGER              :: oiMpol, oiNtor ! save original iMpol and iNtor, which may be changed internally;

  REAL                 :: Bzeta ! toroidal (contravariant) field; calculated in bf00aa; required to convert \dot \t to B^\t, \dot s to B^s;

  INTEGER              :: ifb ! controls whether field lines are followed forward or backwards;

  INTEGER              :: iqfmin, jgd, kgd ! I don't know if all these are required to be global; see bf00aa_out and bf00aa_end;
  REAL                 :: actiongradient ! used to construct QFmin surfaces;

  INTEGER              :: lextrap ! internal value of iextrap; set below in readin; used in fc00aa/fc01aa; given to ex00aa;

  LOGICAL              :: Iwrpj ! internal copy of Lwrpj;

  LOGICAL              :: lswmin(3) ! internal logical representation of Iswmin input;

  REAL,    allocatable :: Rbm(:,:), Zbm(:,:) ! initial boundary harmonics; these must be kept, as spectral condensation algorithm may internally change boundary;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
contains

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine readin !latex \heading{Subroutine readin}

!latex \item The master node reads the input namelist and sets various secondary variables; variables are then broadcast;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item \verb+readin+ : Reads (and broadcasts) the input file.
!latex Various checks on input consistency are performed.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants
  use numerical
  use fileunits
  use inputlist
  use cputiming

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  LOGICAL              :: inputfileexist
  INTEGER              :: mm, nn, imn, ix, ii, ij, ip, lMpol, lNtor, X02BBF
  REAL                 :: X02AJF, X01AAF, machpi
  REAL,    allocatable :: RZ(:,:) ! local array used for reading interface Fourier harmonics from file;
  
  CHARACTER            :: date*8, time*10

  external             :: X02BBF

  BEGIN(readin)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  cput = MPI_WTIME()

  machprec = X02AJF() ; vsmall = 100*machprec ; small = 100*vsmall ; sqrtmachprec = sqrt(machprec) ! returns machine precision;

  largestint = X02BBF(0.0)
  
  machpi = X01AAF(0.0)

  FATALMESS(globals,abs(machpi-pi).gt.vsmall,incorrect value for pi)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  if( myid.eq.0 ) then ! only the master node reads input file and sets secondary variables;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
  !call A00AAF() ! check NAG version;
    
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   call date_and_time(date,time)
   
   call getarg(1,ext) !latex \item The input file name, \verb!ext!, is given as command line input, and the input file itself is \verb!ext.spec!.
   
   inquire(file=trim(ext)//".spec",exist=inputfileexist) ! check if file exists;
   FATALMESS(readin,.not.inputfileexist,the input file does not exist) ! if not, abort;
      
   write(ounit,1000)cput-cpus,date(1:4),date(5:6),date(7:8),time(1:2),time(3:4),time(5:6),machprec,vsmall,small,largestint,ext
   
1000 format("readin : "f10.2" : date="a4"/"a2"/"a2" , "a2":"a2":"a2" ; machine precision="es9.2" ; vsmall="es9.2" ; small="es9.2" ; largestint="i12" ; ext = "a100)
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   open(inunit,file=trim(ext)//".spec",status="old")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/physicslist/ ; recall this is inside the if( myid.eq.0 );
   
   read(inunit,physicslist)!,iostat=ios)
  !FATAL(readin : error reading physicslist,ios.ne.0)
   
   FATAL(readin,Nfp.lt.0)
   FATAL(readin,Mpol.lt.1)
   FATAL(readin,Ntor.lt.0)
   FATAL(readin,Nvol.lt.1 .or. Nvol.gt.MNvol)   
   FATAL(readin,mupftol.le.zero)

  !do ll = 1 , Nvol-1
  ! FATAL(readin,ql(ll)*qr(ll).eq.0)
  ! if( abs(pl(ll)*qr(ll)-pr(ll)*ql(ll)).ne.1 ) write(ounit,'("readin : ll="i4" ; ("i4" ,"i4" ) & ("i4" ,"i4" ) not neigboring ;")')ll,pl(ll),ql(ll),pr(ll),qr(ll)
  ! FATAL(readin : rationals not neighboring,abs(pl(ll)*qr(ll)-pr(ll)*ql(ll)).ne.1)
  !enddo

   do ll = 1 , Nvol
    if( ll.eq.1 ) then
     FATAL(readin,Ni(ll).lt.4) ! radial sub-grid resolution;
    else
     FATAL(readin,Ni(ll).lt.2) ! radial sub-grid resolution;
    endif
   enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/numericslist/ ; recall this is inside the if( myid.eq.0 );
   
   read(inunit,numericslist)!,iostat=ios)
  !FATAL(readin : error reading numericslist,ios.ne.0)
   
   FATAL(readin,Ndiscrete.le.0)
   FATAL(readin,Ls.lt.0 .or. Ls.gt.2)
   FATAL(readin,Nofe.lt.0 .or. Nofe.gt.3)
   FATAL(readin,Nquad.le.0)
   FATAL(readin,Iswmin.lt.0 .or. Iswmin.gt.7)

   FATAL(readin,Lsetmupf.gt.0 .and. Nofe.eq.0) ! must have derivatives of vector potential if magnetic field (ie. transform) is required;

   oiMpol = iMpol ; oiNtor = iNtor ! save original input ; these "input" values may be changed internally;

   if( Ntor.eq.0 ) iNtor=0

   FATAL(readin,iMpol.eq.0)
   FATAL(readin,Ntor.gt.0 .and. iNtor.eq.0)
   
   if( iMpol.lt.0 ) then ; iMpol = 4 * Mpol * abs(iMpol) ! allow user input default;
   endif
   if( iNtor.lt.0 ) then ; iNtor = 4 * Ntor * abs(iNtor) ! allow user input default;
   endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/linearlist/
   
   read(inunit,linearlist)!,iostat=ios)
  !FATAL(readin : error reading linearlist,ios.ne.0)

   FATAL(readin,.not.Ldense .and. .not.Lsparse)
   FATAL(readin,sparsetol.gt.one)
   FATAL(readin,sparsepc.lt.0 .or. sparsepc.gt.2)
   FATAL(readin,ssoromega.lt.zero .or. ssoromega.gt.two)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/nonlinearlist/
   
   read(inunit,nonlinearlist)!,iostat=ios)
  !FATAL(readin : error reading nonlinearlist,ios.ne.0)

   FATAL(readin,forcetol.le.zero)
   FATAL(readin,factor.le.zero)
   FATAL(readin,iextrap.eq.0 .or. iextrap.gt.Nvol)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/diagnosticslist/
   
   read(inunit,diagnosticslist)!,iostat=ios)
  !FATAL(readin : error reading diagnosticslist,ios.ne.0)

   FATAL(readin,odetol.le.zero)
   FATAL(readin,nPpts.lt.0)   
   FATAL(readin,Mpqits.lt.0)
   FATAL(readin,irrMpol.le.0)
   FATAL(readin,irrNtor.lt.0)
   FATAL(readin,Mirrits.lt.0)
   FATAL(readin,irrsvdcut.lt.zero)
   FATAL(readin,irrtol.lt.zero)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! read and check namelist/screenlist
   
   read(inunit,screenlist)!,iostat=ios)
  !FATAL(readin : error reading screenlist,ios.ne.0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
2000 format("readin : "f10.2" : ")

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! screen output of namelist/physicslist/

   write(ounit,2000)cput-cpus

   write(ounit,1001) cput-cpus, Nvol, Nfp, Mpol, Ntor, pscale, Lsetmupf, mupftol, mupfits

1001 format("readin : "f10.2" : Nvol="i3" ; Nfp="i3" ; Mpol="i3" ; Ntor="i3" ; pscale="es13.5" ; Lsetmupf="i1" ; mupftol="es13.5" ; mupfits="i4" ;")
   
  !if( ) write(ounit,'("readin : "f10.2" : tflux="1000(es11.3" ,":))')cput-cpus,( tflux(ll),ll=0,Nvol)
  !if( ) write(ounit,'("readin : "f10.2" : pres ="11x"  "1000(es11.3" ,":))')cput-cpus,(pres(ll),ll=1,Nvol)
  !if( ) write(ounit,'("readin : "f10.2" :  mu  ="11x"  "1000(es11.3" ,":))')cput-cpus,(mu(ll),ll=1,Nvol)
  !if( ) write(ounit,'("readin : "f10.2" : pflux="1000(es11.3" ,":))')cput-cpus,( pflux(ll),ll=0,Nvol)
  !if( ) write(ounit,'("readin : "f10.2" :   Ni ="11x"  "1000(i7"     ,":))')cput-cpus,(Ni(ll),ll=1,Nvol)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! screen output of namelist/numericslist/

   write(ounit,2000)cput-cpus

   write(ounit,1002) cput-cpus, Ndiscrete, Ls, Icoords, Nofe, Nquad, oiMpol, iMpol, oiNtor, iNtor, Iswmin, Lsymagl

1002 format("readin : "f10.2" : Ndiscrete="i2" ; Ls="i2" ; Icoords="i2" ; Nofe="i2" ; Nquad="i3" ; iMpol="i4" ->"i4" ; iNtor="i4" ->"i4" ; Iswmin="i2" ; Lsymagl="L2" ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! screen output of namelist/linearlist/

   write(ounit,2000)cput-cpus
   write(ounit,1020)cput-cpus, Ldense, Lsparse, Lposdef, sparsetol, sparseits, sparsepc, ssoromega

1020 format("readin : "f10.2" : Ldense="L2" ; Lsparse="L2" ; Lposdef="L2" ; sparsetol="es10.2" ; sparseits="i6" ; sparsepc="i2" ; ssoromega="f9.6" ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
! screen output of namelist/nonlinearlist/

   write(ounit,2000)cput-cpus
   write(ounit,1011)cput-cpus, Lc05ndf, Lc05pdf, forcetol, factor, Hsetmupf, Iusesg, pwidth, qwidth, iextrap, ifinited, LuseDM, DMext
1011 format("readin : "f10.2" : Lc05ndf="L2" ; Lc05pdf="L2" ; forcetol="es8.1" ; factor="es9.2" ; Hsetmupf="i1" ; Iusesg="i3&
   " ; pwidth="i2" ; qwidth="i2" ; iextrap="i3" ; ifinited="i4" ; LuseDM="L2" ; DMext= "a2" ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! screen output of namelist/diagnosticslist/
   
   write(ounit,2000)cput-cpus
   write(ounit,1030)cput-cpus, odetol, nPpts, Mpqits, Mirrits, irrMpol, irrNtor, irrsvdcut, irrtol, Lwrpj
   write(ounit,1031)cput-cpus, Nghd, Nadi, Nadj, Lcompare, Levalues, Levectors, Lcurlerr, Ltiming

1030 format("readin : "f10.2" : odetol="es9.2" ; nPpts="i6" ; Mpqits="i3" ; Mirrits="i3" ; irrMpol="i4" ; irrNtor="i4" ; irrsvdcut="es9.2" ; irrtol="es9.2" ; Lwrpj="L2" ;")
1031 format("readin : "f10.2" : Nghd="i3" ; Nadi="i3" ; Nadj="i3" ; Lcompare="L2" ; Levalues="L2" ; Levectors="L2" ; Lcurlerr="L2" ; Ltiming="L2" ;")
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! screen output of namelist/screenlist/; no screen output;
   
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
   
   write(ounit,2000)cput-cpus

  endif ! end of if myid eq 0 loop;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! broadcast command line input

  ClBCAST(ext,100,0)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/physicslist/

  IlBCAST(Nvol,1,0)
  IlBCAST(Nfp,1,0)
  IlBCAST(Mpol,1,0)
  IlBCAST(Ntor,1,0)  
  RlBCAST(pscale,1,0)
  RlBCAST(beta,1,0)
  RlBCAST(tflux,MNvol+1,0)
  RlBCAST(pres,MNvol,0)
  RlBCAST(mu,MNvol,0)
  RlBCAST(pflux,MNvol+1,0)
  IlBCAST(pl,MNvol+1,0)
  IlBCAST(ql,MNvol+1,0)
  IlBCAST(pr,MNvol+1,0)
  IlBCAST(qr,MNvol+1,0)
  IlBCAST(Ni,MNvol,0)
  IlBCAST(Lsetmupf,1,0)
  RlBCAST(mupftol,1,0)
  IlBCAST(mupfits,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/numericslist/

  IlBCAST(Ndiscrete,1,0)
  IlBCAST(Ls,1,0)
  IlBCAST(Icoords,1,0)
  IlBCAST(Nofe,1,0)
  IlBCAST(Nquad,1,0)
  IlBCAST(iMpol,1,0)
  IlBCAST(iNtor,1,0)
  IlBCAST(Iswmin,1,0)
  LlBCAST(Lsymagl,1,0)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! broadcast namelist/nonlinearlist/

  LlBCAST(Lc05ndf,1,0)
  LlBCAST(Lc05pdf,1,0)
  RlBCAST(forcetol,1,0)
  RlBCAST(forceerr,1,0)
  RlBCAST(factor,1,0)
  IlBCAST(Hsetmupf,1,0)
  IlBCAST(Iusesg,1,0)
  IlBCAST(iextrap,1,0)
  IlBCAST(pwidth,1,0)
  IlBCAST(qwidth,1,0)
  IlBCAST(ifinited,1,0)
  LlBCAST(LuseDM,1,0)
  ClBCAST(DMext,2,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/linearlist/

  LlBCAST(Ldense,1,0)
  LlBCAST(Lsparse,1,0)
  LlBCAST(Lposdef,1,0)
  RlBCAST(sparsetol,1,0)
  IlBCAST(sparseits,1,0)
  IlBCAST(sparsepc,1,0)
  RlBCAST(ssoromega,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/diagnosticslist/

  RlBCAST(odetol,1,0)
  IlBCAST(nPpts,1,0)
  IlBCAST(nPtrj,(MNvol),0)
  IlBCAST(Mpqits,1,0)
  IlBCAST(p1,(MNvol),0)
  IlBCAST(q1,(MNvol),0)
  IlBCAST(p2,(MNvol),0)
  IlBCAST(q2,(MNvol),0)
  IlBCAST(npq,(MNvol),0)
  IlBCAST(Mirrits,1,0)
  IlBCAST(irrMpol,1,0)
  IlBCAST(irrNtor,1,0)
  RlBCAST(irrsvdcut,1,0)
  RlBCAST(irrtol,1,0)
  LlBCAST(Lwrpj,1,0)
  IlBCAST(Nghd,1,0)
  IlBCAST(Nadi,1,0)
  IlBCAST(Nadj,1,0)
  LlBCAST(Lcompare,1,0)
  LlBCAST(Levalues,1,0)
  LlBCAST(Levectors,1,0)
  LlBCAST(Lcurlerr,1,0)
  LlBCAST(Ltiming,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! broadcast namelist/screenlist/

! BSCREENLIST ! broadcast screenlist; this is expanded by Makefile; do not remove;
  LlBCAST(Wreadin,1,0)
  LlBCAST(Wwritin,1,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on physicslist;

  pi2nfp = pi2 / Nfp ; pi2pi2nfpquarter = pi2 * pi2nfp * quarter ! numerical constants;


  mn  =  Ntor + 1 +  Mpol * ( 2*  Ntor + 1 ) ! Fourier resolution of interface geometry & vector potential;

  Ngdof = ( Nvol-1 ) * ( mn + mn-1 ) ! degrees of freedom in geometry; this excludes the outermost interface as a degree of freedom;


  IALLOCATE(im,(1:mn))
  IALLOCATE(in,(1:mn))
  CALL(gi00ab,(Mpol,Ntor,Nfp,mn,im,in)) ! this sets the im and in mode identification arrays;


  lMpol = 2*Mpol ; lNtor = 2*Ntor

  mne = lNtor + 1 + lMpol * ( 2* lNtor + 1 ) ! resolution of metrics; enhanced resolution; see me00ab;

  IALLOCATE(ime,(1:mne))
  IALLOCATE(ine,(1:mne))
  CALL(gi00ab,(lMpol,lNtor,Nfp,mne,ime,ine))


  mns = iNtor + 1 + iMpol * ( 2* iNtor + 1 ) ! resolution of straight-field line transformation on interfaces; see tr00ab;

  IALLOCATE(ims,(1:mns))
  IALLOCATE(ins,(1:mns))
  CALL(gi00ab,(iMpol,iNtor,Nfp,mns,ims,ins)) ! note that the field periodicity factor is included in in;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on numericslist;

  lswmin(1:3) = (/ .false. , .false. , .false. /)
  
  if( Iswmin.eq.1 .or. Iswmin.eq.3 .or. Iswmin.eq.5 .or. Iswmin.eq.7 ) lswmin(1)=.true. ! initially convert interfaces (incl. boundary) to spectrally condensed angle; see spec;
  if( Iswmin.eq.2 .or. Iswmin.eq.3 .or. Iswmin.eq.6 .or. Iswmin.eq.7 ) lswmin(2)=.true. ! write spectrally condensed boundary to restart file; see writin;
  if( Iswmin.eq.4 .or. Iswmin.eq.5 .or. Iswmin.eq.6 .or. Iswmin.eq.7 ) lswmin(3)=.true. ! early termination after initial spectral condensation; see spec;

!latex \item The resolution of the radial sub-sub-grid is given \verb+Nquad+.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on linearlist;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on nonlinearlist;

  select case(ifinited)
  case(   : -1 ) ; dfd = ten**(ifinited)
  case( 0 :    ) ; dfd =  sqrtmachprec 
  end select

  if( lextrap.gt.0 ) then ; lextrap = iextrap
  else                    ; lextrap = Nvol 
  endif  

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! set internal parameters that depend on diagnosticslist;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \heading{Input geometry}
!latex \item The geometry of the $l$-th interface, for $l=0,N$ where $N\equiv$ \verb+Nvol+, is described by a set of Fourier harmonics, using an arbitrary poloidal angle,
!latex \be R_l(\t,\z)=\sum_{j}R_{j,l}\cos(m_j\t-n_j\z), \;\;\; Z_l(\t,\z)=\sum_{j}Z_{j,l}\sin(m_j\t-n_j\z). \ee
!latex \item These harmonics are read from the \verb+ext.spec+ file and come directly after the namelists described above.
!latex The required format is as follows:
!latex \be \begin{array}{ccccccccc}
!latex m_1 & n_1 & R_{1,0} & Z_{1,0} & R_{1,1} & Z_{1,1} & \dots & R_{1,N} & Z_{1,N} \\
!latex m_2 & n_2 & R_{2,0} & Z_{2,0} & R_{2,1} & Z_{2,1} & \dots & R_{2,N} & Z_{2,N} \\
!latex \dots \\
!latex m_j & n_j & R_{j,0} & Z_{j,0} & R_{j,1} & Z_{j,1} & \dots & R_{j,N} & Z_{j,N} \\
!latex \dots
!latex \end{array}
!latex \ee
!latex
!latex \item The coordinate axis corresponds to $j=0$ and the outermost boundary corresponds to $j=$\verb+Nvol+.
!latex \item An arbitrary selection of harmonics may be inluded in any order, but only those within the range specified by \verb+Mpol+ and \verb+Ntor+ will be used.
!latex \item The geometry of {\em all} the interfaces, i.e. $l=0,N$, including the degenerate `coordinate-axis' interface, must be given.

  RALLOCATE(Rbc,(0:Nvol,0:1,1:mn)) ! interface Fourier harmonics and radial derivatives;
  RALLOCATE(Zbs,(0:Nvol,0:1,1:mn))

  if( myid.eq.0 ) then

   RALLOCATE(RZ,(1:2,0:Nvol)) ! temp array for reading input;

   do ! will read in Fourier harmonics until the end of file is reached;
    
    read(inunit,*,iostat=ios)mm, nn, RZ
    if( ios.ne.0 ) exit
    do imn = 1 , mn ! loop over harmonics within range;
     if( mm.eq.im(imn) .and. nn*Nfp.eq.in(imn) ) then ; Rbc(0:Nvol,0,imn) = RZ(1,0:Nvol) ! select relevant harmonics;
                                                        Zbs(0:Nvol,0,imn) = RZ(2,0:Nvol) ! select relevant harmonics;
     endif
    enddo ! end of do imn;

   enddo ! end of do;

   DEALLOCATE(RZ)

  endif ! end of if myid.eq.0 loop; only the master will read the input file; all variables need to be broadcast;

  RlBCAST(Rbc(0:Nvol,0,1:mn),(Nvol+1)*mn,0)
  RlBCAST(Zbs(0:Nvol,0,1:mn),(Nvol+1)*mn,0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( myid.eq.0 ) close(inunit) ! finished reading input file;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  if( myid.eq.0 ) then 

   RALLOCATE(Rbm,(0:1,1:mn)) ! Fourier harmonics of initial boundary, including ll=1 interface, before spectral condensation;
   RALLOCATE(Zbm,(0:1,1:mn))

   Rbm(0,1:mn) = Rbc(  1 ,0,1:mn) ; Zbm(0,1:mn) = Zbs(  1 ,0,1:mn)
   Rbm(1,1:mn) = Rbc(Nvol,0,1:mn) ; Zbm(1,1:mn) = Zbs(Nvol,0,1:mn)

  endif

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!latex \heading{Allocating the vector potential}
  
!latex \item The basic quantities are the covariant components of the vector potential at the radial sub-grid:
!latex 
!latex $A_{\t,l,j,p,i}\equiv$\verb+At(l,j,p)%s(i)+,
!latex 
!latex $A_{\z,l,j,p,i}\equiv$\verb+Az(l,j,p)%s(i)+.
!latex
!latex For all annuli, $l=2,$\verb+Nvol+, the degrees of freedom in the vector potential include $j=1,$\verb+mn+, $p=0,$\verb+Nofe+ and $i=0,$\verb+Ni(l)+,
!latex except the $A_{\t,l,j,0,0}$ and $A_{\z,l,j,0,0}$, which are constrained by the gauge and interface conditions at the inner interface,
!latex and the $A_{\t,l,j,0,Ni}=m_j f_j$ and $A_{\z,l,j,0,Ni}=-n_j f_j$, which are constrained by the interface conditions at the outer interface.

!latex \item The innermost volume is a little different (see \verb+ma01af+), as the $A_{\t,l,j,0,p}$ and $A_{\z,l,j,0,p}$ are constrained regularity and gauge and
!latex are not degrees of freedom.

!latex \item In volume $l$, for $s\in[s_{l,i-1},s_{l,i}]$, the $j$-th harmonic of each component is given by
!latex \be A_{\t,l,j}(s)=\sum_{p=0}^{Nofe}\left[A_{\t,l,j,p,i-1} \varphi_{L,p}(s) + A_{\t,l,j,p,i} \varphi_{R,p}(s)  \right], \ee
!latex where the $\varphi(s)_{L,p}$ are the finite-element basis functions.
  
  ALLOCATE(At,(1:Nvol,1:mn,0:Nofe)) ! type subgrid;
  ALLOCATE(Az,(1:Nvol,1:mn,0:Nofe)) ! type subgrid;
  
!latex \item In each volume, the total degrees of freedom in the Beltrami linear system, \verb+NBdof(1:Nvol)+, is determined.
!latex This depends on \verb+Mpol+, \verb+Ntor+, \verb+Nofe+ and \verb+Ni(ll)+.
  
  IALLOCATE(NBdof,(1:Nvol))
  
  do ll = 1 , Nvol ! allocate vector potential in each annulus;
   
   NBdof(ll) = 2 * mn * ( Nofe+1 ) * ( Ni(ll)+1 )  -  2 * mn + (mn-1) ! total degrees of freedom, plus outer boundary constraints;

   if( ll.eq.1 ) then ; NBdof(ll) = NBdof(ll) - 2 * mn * (Nofe-1) - (1+Ntor) ! inner boundary constraints;
   else               ; NBdof(ll) = NBdof(ll) - 2 * mn                       ! inner boundary constraints;
   endif
   
   if( myid.ne.modulo(ll-1,numprocs) ) cycle ! the construction of the vector potential is distributed over cpus;
   
   do ij = 1,mn ! loop over Fourier harmonics;
    do ip = 0,Nofe ! loop over derivatives;
     
     RALLOCATE(At(ll,ij,ip)%s,(0:Ni(ll))) ! covariant coefficients of vector potential;
     RALLOCATE(Az(ll,ij,ip)%s,(0:Ni(ll)))
     
     IALLOCATE(At(ll,ij,ip)%i,(-1:Ni(ll)+1)) ! degree of freedom index;
     IALLOCATE(Az(ll,ij,ip)%i,(-1:Ni(ll)+1)) ! include padding for simple loop logic in ma01aa;

    enddo ! end of do ip;
   enddo ! end of do ij;
   
!latex \item To employ standard `canned' routines for solving linear systems, the vector potential degrees-of-freedom in each annulus 
!latex need to be written as a single `column' vector.
!latex The location of $A_{\t,l,j,i,p}$ in this vector is given by \verb+At(l,j,p)%i(i)+ and $A_{\z,l,j,i,p}$ by \verb+Az(l,j,p)%i(i)+.
!latex Note that better ways of packing this vector may exist, particularly so given that the Beltrami linear system is sparse, and
!latex sparse linear solvers could be employed. See \verb+mp00aa+.
   
   select case(ll)
    
   case(1)
    
    ix = 0 ! degree of freedom index; reset to 0 in each annulus;
    
    do ij = 1 , mn
     do ip = 0 , Nofe
      do ii = 0 , Ni(ll)
       
       if( ii.eq.0 .and. ip.ne.(ip/2)*2 ) cycle ! then ip is odd; coordinate origin boundary condition;

       FATALMESS(global,ii.eq.0 .and. ip.eq.1,invalid logic)
       FATALMESS(global,ii.eq.0 .and. ip.eq.3,invalid logic)
       FATALMESS(global,ii.eq.0 .and. ip.eq.5,invalid logic)

       if( ii.eq.0 .and. ip.eq.0 ) then

         ix = ix+1 ; At(ll,ij,ip)%i(ii) = ix ! write(ounit,'("readin : ix="i5" : "a2"_{"i3","i2","i1"}")')ix,"At",ij,ii,ip ; pause

        if( im(ij).ne.0 ) then
         ix = ix+1 ; Az(ll,ij,ip)%i(ii) = ix ! write(ounit,'("readin : ix="i5" : "a2"_{"i3","i2","i1"}")')ix,"Az",ij,ii,ip ; pause
        endif

       endif

       if( ii.eq.0 .and. ip.gt.0 ) then
        ix = ix+1 ; At(ll,ij,ip)%i(ii) = ix ! write(ounit,'("readin : ix="i5" : "a2"_{"i3","i2","i1"}")')ix,"At",ij,ii,ip ; pause
        ix = ix+1 ; Az(ll,ij,ip)%i(ii) = ix ! write(ounit,'("readin : ix="i5" : "a2"_{"i3","i2","i1"}")')ix,"Az",ij,ii,ip ; pause
       endif
       
       if( ii.gt.0 .and. ii.lt.Ni(ll) ) then
        ix = ix+1 ; At(ll,ij,ip)%i(ii) = ix ! write(ounit,'("readin : ix="i5" : "a2"_{"i3","i2","i1"}")')ix,"At",ij,ii,ip
        ix = ix+1 ; Az(ll,ij,ip)%i(ii) = ix ! write(ounit,'("readin : ix="i5" : "a2"_{"i3","i2","i1"}")')ix,"Az",ij,ii,ip
       endif
       
       if( ii.eq.Ni(ll) ) then
        
        if( ip.eq.0 .and. ij.gt.1 ) then
         ix = ix + 1         
         if    ( im(ij).ne.0 .and. in(ij).ne.0 ) then ; At(ll,ij,ip)%i(ii) = ix ; Az(ll,ij,ip)%i(ii) = ix ! At & Az harmonics are related; At = d_\t f, Az = d_\z f;
         elseif( im(ij).eq.0 .and. in(ij).ne.0 ) then ;                           Az(ll,ij,ip)%i(ii) = ix
         elseif( im(ij).ne.0 .and. in(ij).eq.0 ) then ; At(ll,ij,ip)%i(ii) = ix                          
         endif
        endif ! end of if( ip.eq.0 .and. ij.gt.1 );
        
        if( ip.gt.0 ) then 
         ix = ix+1 ; At(ll,ij,ip)%i(ii) = ix
         ix = ix+1 ; Az(ll,ij,ip)%i(ii) = ix
        endif ! end of if( ip.gt.0 );

       endif ! end of  if( ii.eq.Ni(ll) );
      
      enddo ! end of do ii;
     enddo ! end of do ip;
    enddo ! end of do ij;
    
    if( ix.ne.NBdof(ll) ) then 
     write(ounit,'("readin : "f10.2" : myid="i3" ; ix,NBdof(ll)=",2i6)')cput-cpus,myid,ix,NBdof(ll)
    endif

    FATALMESS(global,ix.ne.NBdof(ll),check simple torus degree-of-freedom logic)
    
   case(2:)
    
    ix = 0 ! degree of freedom index; reset to 0 in each annulus;
    
    do ij = 1 , mn
     do ip = 0 , Nofe
      do ii = 0 , Ni(ll)
       
       if    ( ii.eq. 0     .and. ip.eq.0  ) then ! no freedom; inner interface constraints;
        
       elseif( ii.eq.Ni(ll) .and. ip.eq.0  ) then ! reduced freedom due to interface constraints;
        
        if( ij.gt.1 ) then 
         
         ix = ix + 1
         
         if    ( im(ij).ne.0 .and. in(ij).ne.0 ) then ; At(ll,ij,ip)%i(ii) = ix ; Az(ll,ij,ip)%i(ii) = ix ! these are not independent degrees of freedom; 
         elseif( im(ij).eq.0 .and. in(ij).ne.0 ) then ;                           Az(ll,ij,ip)%i(ii) = ix
         elseif( im(ij).ne.0 .and. in(ij).eq.0 ) then ; At(ll,ij,ip)%i(ii) = ix
         endif
         
        endif ! end of if( ij.gt.1 ) ;
        
       else ! this is an independent degree of freedom;
        
        ix = ix+1 ; At(ll,ij,ip)%i(ii) = ix
        ix = ix+1 ; Az(ll,ij,ip)%i(ii) = ix
        
       endif ! end of if; elseif;
      enddo ! end of do ii;
     enddo ! end of do ip;
    enddo ! end of do ij;
    
    FATALMESS(global,ix.ne.NBdof(ll),check annular degree-of-freedom logic)
    
   case default
    
    FATALMESS(global,.true.,invalid value for ll)
    
   end select
   
  enddo ! end of do ll = 1,Nvol loop;

!latex \item The matrix representing the Beltrami linear system, \verb+MB(1:NBdof,1:NBdof)+, 
!latex and the Beltrami `right-hand-side' \verb+MR(1:NBdof)+, arising from the inhomogeneous boundary conditions associated with non-zero toroidal and poloidal fluxes,
!latex are allocated/deallocated in \verb+ma02aa+ and assigned values in \verb+ma01ab+.
!latex \item The routine \verb+ma01ab+ contains more documentation on the construction of the Beltrami linear system.
!latex The solution to the linear system, i.e. the Beltrami field itself, is constructed in \verb+mp00aa+.

!latex \item The \verb+Atmn(0:2,1:mn)+ and \verb+Azmn(0:2,1:mn)+ are workspace arrays used for interpolation.

  RALLOCATE(Atmn,(0:2,1:mn)) ! workspace interpolation array;
  RALLOCATE(Azmn,(0:2,1:mn)) 

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(readin)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine readin

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine writin !latex \heading{writin}
!latex \item The restart file is written.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only :
  use numerical, only :
  use fileunits, only : ounit, dataunit
  use cputiming
  use inputlist

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS
  
  INTEGER              :: imn, ii, jj, kk, Lcurv, mm, nn
  REAL                 :: lss
  
  BEGIN(writin)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  FATAL(writin,myid.ne.0)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  open(dataunit,file=trim(ext)//".end",status="unknown") ! restart input file;

  write(dataunit,'("&physicslist")')
  write(dataunit,'(" Nfp        = "i9        )')Nfp
  write(dataunit,'(" Mpol       = "i9        )')Mpol
  write(dataunit,'(" Ntor       = "i9        )')Ntor
  write(dataunit,'(" Nvol       = "i9        )')Nvol
  write(dataunit,'(" pscale     = "es23.15   )')pscale
  write(dataunit,'(" beta       = "es23.15   )')beta
  write(dataunit,'(" tflux      = "999es23.15)')tflux(0:Nvol)
  write(dataunit,'(" pres       = "999es23.15)')pres(1:Nvol)
  write(dataunit,'(" mu         = "999es23.15)')mu(1:Nvol)
  write(dataunit,'(" pflux      = "999es23.15)')pflux(0:Nvol)
  write(dataunit,'(" pl         = "999i23    )')pl(0:Nvol)
  write(dataunit,'(" ql         = "999i23    )')ql(0:Nvol)
  write(dataunit,'(" pr         = "999i23    )')pr(0:Nvol)
  write(dataunit,'(" qr         = "999i23    )')qr(0:Nvol)
  write(dataunit,'(" Ni         = "999i23    )')Ni(1:Nvol)
  write(dataunit,'(" Lsetmupf   = "i9        )')Lsetmupf
  write(dataunit,'(" mupftol    = "es10.2    )')mupftol
  write(dataunit,'(" mupfits    = "i9        )')mupfits
  write(dataunit,'("/")')

  write(dataunit,'("&numericslist")')
  write(dataunit,'(" Ndiscrete  = "i9)')Ndiscrete
  write(dataunit,'(" Ls         = "i9)')Ls
  write(dataunit,'(" Icoords    = "i9)')Icoords
  write(dataunit,'(" Nofe       = "i9)')Nofe
  write(dataunit,'(" Nquad      = "i9)')Nquad
  write(dataunit,'(" iMpol      = "i9)')oiMpol
  write(dataunit,'(" iNtor      = "i9)')oiNtor
  write(dataunit,'(" Iswmin     = "i9)')Iswmin
  write(dataunit,'(" Lsymagl    = "L9)')Lsymagl
  write(dataunit,'("/")')

  write(dataunit,'("&linearlist")')
  write(dataunit,'(" Ldense      = "L9    )')Ldense
  write(dataunit,'(" Lsparse     = "L9    )')Lsparse
  write(dataunit,'(" Lposdef     = "L9    )')Lposdef
  write(dataunit,'(" sparsetol   = "es10.2)')sparsetol
  write(dataunit,'(" sparseits   = "i9    )')sparseits
  write(dataunit,'(" sparsepc    = "i9    )')sparsepc
  write(dataunit,'(" ssoromega   = "f9.6  )')ssoromega
  write(dataunit,'("/")')

  write(dataunit,'("&nonlinearlist")')
  write(dataunit,'(" Lc05ndf    = "L9    )')Lc05ndf
  write(dataunit,'(" Lc05pdf    = "L9    )')Lc05pdf
  write(dataunit,'(" forcetol   = "es10.2)')forcetol
  write(dataunit,'(" forceerr   = "es23.15   )')forceerr
  write(dataunit,'(" factor     = "es10.2)')factor
  write(dataunit,'(" Hsetmupf   = "i9    )')Hsetmupf
  write(dataunit,'(" Iusesg     = "i9    )')Iusesg
  write(dataunit,'(" pwidth     = "i9    )')pwidth
  write(dataunit,'(" qwidth     = "i9    )')qwidth
  write(dataunit,'(" iextrap    = "i9    )')iextrap
  write(dataunit,'(" ifinited   = "i9    )')ifinited
  write(dataunit,'(" LuseDM     = "L9    )')LuseDM
 !write(dataunit,'(" DMext      = "a2    )')DMext
  write(dataunit,*)"DMext      = '"//DMext//"'"
  write(dataunit,'("/")')

  write(dataunit,'("&diagnosticslist")')
  write(dataunit,'(" odetol    = "es10.2)')odetol
  write(dataunit,'(" nPpts     = "i9    )')nPpts
  write(dataunit,'(" Mpqits    = "i9    )')Mpqits
  write(dataunit,'(" p1        = "999i6 )')(p1(ll),ll=1,Nvol)
  write(dataunit,'(" q1        = "999i6 )')(q1(ll),ll=1,Nvol)
  write(dataunit,'(" p2        = "999i6 )')(p2(ll),ll=1,Nvol)
  write(dataunit,'(" q2        = "999i6 )')(q2(ll),ll=1,Nvol)
  write(dataunit,'(" npq       = "999i6 )')(npq(ll),ll=1,Nvol)
  write(dataunit,'(" nPtrj     = "999i6 )')nPtrj(1:Nvol)
  write(dataunit,'(" Mirrits   = "i9    )')Mirrits
  write(dataunit,'(" irrMpol   = "i9    )')irrMpol
  write(dataunit,'(" irrNtor   = "i9    )')irrNtor
  write(dataunit,'(" irrsvdcut = "es10.2)')irrsvdcut
  write(dataunit,'(" irrtol    = "es10.2)')irrtol
  write(dataunit,'(" Lwrpj     = "L9    )')Lwrpj
  write(dataunit,'(" Nghd      = "i9    )')Nghd
  write(dataunit,'(" Nadi      = "i9    )')Nadi
  write(dataunit,'(" Nadj      = "i9    )')Nadj
  write(dataunit,'(" Lcompare  = "L9    )')Lcompare
  write(dataunit,'(" Levalues  = "L9    )')Levalues
  write(dataunit,'(" Levectors = "L9    )')Levectors
  write(dataunit,'(" Lcurlerr  = "L9    )')Lcurlerr
  write(dataunit,'(" Ltiming   = "L9    )')Ltiming
  write(dataunit,'("/")')

  write(dataunit,'("&screenlist")')
! WSCREENLIST ! write screenlist; this is expanded by Makefile ; do not remove;
  write(dataunit,'(" Wreadin = "L1)')Wreadin
  write(dataunit,'(" Wwritin = "L1)')Wwritin
  write(dataunit,'("/")')

!latex \item Note that the boundary harmonics are changed by the spectral condensation routine \verb+sw00ab+, which is called by \verb+spec+.
!latex At finite resolution, as the boundary harmonics are changed, the boundary surface itself may change. 
!latex For restarts at potentially higher resolution, the original boundary harmonics (saved in \verb+Rbm+ and \verb+Zbm+, see \verb+global/readin+) are written to file.

  if( lswmin(2) ) then ! write spectrally condensed boundary to restart file;
   Rbm(0,1:mn)=Rbc(  1 ,0,1:mn) ; Zbm(0,1:mn)=Zbs(  1 ,0,1:mn)
   Rbm(1,1:mn)=Rbc(Nvol,0,1:mn) ; Zbm(1,1:mn)=Zbs(Nvol,0,1:mn)
  endif

  do imn = 1 , mn ; mm = im(imn) ; nn = in(imn) / Nfp
   write(dataunit,'(2i6,999es23.15)') mm, nn, ( Rbc(ll,0,imn), Zbs(ll,0,imn), ll = 0, Nvol-1 ), Rbm(1,imn), Zbm(1,imn)
  enddo
  
  close(dataunit)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  open(dataunit,file="."//trim(ext)//".lambda",status="unknown",form="unformatted") ! transformation to straight-field-line angle on interfaces;
  write(dataunit)mns,Nvol
  write(dataunit)ims(1:mns)
  write(dataunit)ins(1:mns)
  write(dataunit)sflangle(1:Nvol,0:1,1:mns)
  close(dataunit)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  open(dataunit,file="."//trim(ext)//".grid",status="unknown") ! coordinate grid;
  write(dataunit,'(3i9)')Nt,Nz,Nvol
  do ll = 1 , Nvol ! volumes;
   write(dataunit,'(i3)')Ni(ll) ! sub-grid radial resolution;
   do ii = 0,Ni(ll) ! sub-grid;
    lss = ss(ll)%s(ii)
    Lcurv = 0
    CALL(co01aa,(lss,Lcurv)) ! only Rij(0,:),Zij(0,:) are required;
    write(dataunit,'(2f15.10)')((Rij(0,1+jj+kk*Nt),Zij(0,1+jj+kk*Nt),jj=0,Nt-1),kk=0,Nz-1)
   enddo
  enddo  
  close(dataunit)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(writin)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine writin

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end module allglobal

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module pjhamilto
  INTEGER              :: io
  REAL,    allocatable :: Itor(:,:), Gpol(:,:), spmn(:,:,:)
end module pjhamilto

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

module mupfcount
  INTEGER              :: imupf
end module mupfcount

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
