!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Interpolates interface geometry.
!latex The interface geometry is given in \verb+Rbc(0:Nvol,0,1:mn)+ and \verb+Zbs(0:Nvol,0,1:mn)+.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine ih00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only :
  use numerical, only :
  use fileunits, only : ounit
  use inputlist, only : Wih00aa, Nvol, Icoords, Ni
  use cputiming
  use allglobal, only : myid, cpus, mn, im, in, ss, Rbc, Zbs, iss

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  LOCALS

  INTEGER :: ll, imn, ie01bef ! warning :: ll is not global;

  BEGIN(ih00aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  do imn = 1,mn

   select case(Icoords)

   case(0)
   
 !latex \item If \verb+Icoords.eq.0+, the coordinates are constructed by a piecewise linear interpolation of the interface harmonics.

    do ll = 1,Nvol
     Rbc(ll,1,imn) = ( Rbc(ll,0,imn) - Rbc(ll-1,0,imn) ) / ( ss(ll)%s(Ni(ll))-ss(ll)%s(0) ) ! linear derivatives;
     Zbs(ll,1,imn) = ( Zbs(ll,0,imn) - Zbs(ll-1,0,imn) ) / ( ss(ll)%s(Ni(ll))-ss(ll)%s(0) ) ! linear derivatives;
    enddo
    
   case(1)
    
!latex \item If \verb+Icoords.eq.1+, the coordinates are constructed by a piecewise cubic interpolation of the interface harmonics, provided by the NAG routine \verb+E01BEF+.

    ie01bef=1 ; call E01BEF( Nvol+1 , iss(0:Nvol) , Rbc(0:Nvol,0,imn) , Rbc(0:Nvol,1,imn) , ie01bef ) 
    FATAL(ih00aa,ie01bef.ne.0)
    
    ie01bef=1 ; call E01BEF( Nvol+1 , iss(0:Nvol) , Zbs(0:Nvol,0,imn) , Zbs(0:Nvol,1,imn) , ie01bef )
    FATAL(ih00aa,ie01bef.ne.0)

   case(2)

!latex \item If \verb+Icoords.eq.2+, the coordinates are constructed by a piecewise cubic interpolation of the interface harmonics, (manually).
    
    Rbc(0       ,1,imn) = ( Rbc(1           ,0,imn) - Rbc(0           ,0,imn) ) / ( iss(1           ) - iss(0           ) )
    Rbc(1:Nvol-1,1,imn) = ( Rbc(1+1:Nvol-1+1,0,imn) - Rbc(1-1:Nvol-1-1,0,imn) ) / ( iss(1+1:Nvol-1+1) - iss(1-1:Nvol-1-1) )
    Rbc(  Nvol  ,1,imn) = ( Rbc(    Nvol    ,0,imn) - Rbc(    Nvol-1  ,0,imn) ) / ( iss(    Nvol    ) - iss(    Nvol-1  ) )
    
    Zbs(0       ,1,imn) = ( Zbs(1           ,0,imn) - Zbs(0           ,0,imn) ) / ( iss(1           ) - iss(0           ) )
    Zbs(1:Nvol-1,1,imn) = ( Zbs(1+1:Nvol-1+1,0,imn) - Zbs(1-1:Nvol-1-1,0,imn) ) / ( iss(1+1:Nvol-1+1) - iss(1-1:Nvol-1-1) )
    Zbs(  Nvol  ,1,imn) = ( Zbs(    Nvol    ,0,imn) - Zbs(    Nvol-1  ,0,imn) ) / ( iss(    Nvol    ) - iss(    Nvol-1  ) )

   case default
    
    FATAL(ih00aa : invalid Icoords,.true.)
    
   end select
   
  enddo ! end of do imn=1,mn
  
!latex \item In all cases, the radial derivatives of the coordinate harmonics are saved in \verb+Rbc(0:Nvol,1,1:mn)+ and \verb+Zbs(0:Nvol,1,1:mn)+.
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
  RETURN(ih00aa)
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

end subroutine ih00aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
