!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item Compute spectral-width extremizing condition, called iteratively, 
!latex by \verb+cb00aa+, which is called by \verb+fc00aa+.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

subroutine sw02aa ! depends on Rbc,Zbs;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  use constants, only : zero, one
  use numerical, only : vsmall
  use fileunits, only : ounit
  use inputlist, only : Wsw02aa, Nfp, Ntor, pwidth, qwidth
  use cputiming, only : Tsw02aa
  use allglobal, only : myid, cpus, ll, Rbc, Zbs, swI, &
                        Nt, Nz, Ntz, mn, im, in, isr, trigm, trign, trigwk, ijreal, ijimag, jireal, jiimag, efmn, ofmn, cfmn, sfmn

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  LOCALS

  INTEGER           :: imn, jj, kk, jk, jmn, ifail, kmn, mmpp, nnqq, mp, nn, np, deltamn
  REAL              :: swidth, tt, zz, tb
  REAL, allocatable :: dRmndl(:,:), dZmndl(:,:)

  BEGIN(sw02aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item The spectral width is defined
!latex % \be M = \sum_{m=1}^{M} (m^p+n^q) \sum_{n=-N}^{N} \left( R_{mn}^2 + Z_{mn}^2 \right), \ee
!latex \be M = \sum_i (m_i^p+n_i^q) \left(R_i^2+Z_i^2\right).\ee
!latex where $p\equiv$ \verb+pwidth+, $q\equiv$ \verb+qwidth+ are integers given as input and $m_i^p=0$ for $m_i=0$, $n_i^q=0$ for $n_i=0$.
  
  swidth = zero ! initialize summation quantity;
  
  do imn = 1,mn ; mmpp = 0 ; nnqq = 0

   if( im(imn).ne.0 .and. pwidth.gt.0 ) mmpp = abs(im(imn)    )**pwidth
   if( in(imn).ne.0 .and. qwidth.gt.0 ) nnqq = abs(in(imn)/Nfp)**qwidth
   
   swidth = swidth + ( mmpp + nnqq ) * ( Rbc(ll,0,imn)**2 + Zbs(ll,0,imn)**2 )
   
  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! ijreal = R_\t ; ijimag = Z_t ;
  efmn(1:mn) = zero ; sfmn(1:mn) = zero
  call invfft( mn , im , in , efmn(1:mn) , -im*Rbc(ll,0,1:mn) , +im*Zbs(ll,0,1:mn) , sfmn(1:mn) , Nt , Nz , ijreal(1:Ntz) , ijimag(1:Ntz) , isr , trigm , trign , trigwk )
  
!latex \item Also computed is $I = R_\theta X + Z_\theta Y$ where
!latex \be X = \sum_i (m_i^p+n_i^q)R_{i} \cos(m\theta-n\phi), \qquad
!latex     Y = \sum_i (m_i^p+n_i^q)Z_{i} \sin(m\theta-n\phi). \ee

  efmn(1:mn) = zero ; sfmn(1:mn) = zero ! Fourier harmonics; dummy workspace;  

  do imn = 1,mn ; mmpp = 0 ; nnqq = 0

   if( im(imn).ne.0 ) mmpp = abs(im(imn)    )**pwidth
   if( in(imn).ne.0 ) nnqq = abs(in(imn)/Nfp)**qwidth

   efmn(imn) = ( mmpp + nnqq ) * Rbc(ll,0,imn)
   sfmn(imn) = ( mmpp + nnqq ) * Zbs(ll,0,imn)
  enddo
  
! jireal = X ; jiimag=Y ;
  ofmn(1:mn)=zero ; cfmn(1:mn)=zero
  call invfft( mn , im , in , efmn(1:mn) , ofmn(1:mn) , cfmn(1:mn) , sfmn(1:mn) , Nt , Nz , jireal(1:Ntz) , jiimag(1:Ntz) , isr , trigm , trign , trigwk )

!   I        =   R_\t            X             + Z_\t            Y                
  swI(1:Ntz) = ( ijreal(1:Ntz) * jireal(1:Ntz) + ijimag(1:Ntz) * jiimag(1:Ntz) ) ! / swidth ! SHOULD normalize I on discrete grid; this is odd;

! note that swI = I is passed through global and is Fourier decomposed in cb00aa;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
! now compute spectral-length constraint;

!  bRbc(1:Ntor) = zero ; bZbs(1:Ntor) = zero
!
!  do nn = 1 , Ntor
!   do jmn = 1 , mn
!    bRbc(nn) = bRbc(nn) + deltamn( abs(in(jmn)) , nn ) * Rbc(ll,0,jmn)
!    bZbs(nn) = bZbs(nn) + deltamn(     in(jmn)  , nn ) * Zbs(ll,0,jmn)
!   enddo
!  enddo
!  
!  bX(1:mn) = zero ; bY(1:mn) = zero
!
!  do jmn = 1 , mn
!   do nn = 1 , Ntor ; np = nn**pwidth
!    bX(jmn) = bX(jmn) + np * bRbc(nn) * deltamn( abs(in(jmn)) , nn )
!    bY(jmn) = bY(jmn) + np * bZbs(nn) * deltamn(     in(jmn)  , nn )
!   enddo
!  enddo
!  
!  call invfft( mn , im , in , bX(1:mn) , ofmn(1:mn) , cfmn(1:mn) , bY(1:mn) , Nt , Nz , jireal(1:Ntz) , jiimag(1:Ntz) , isr , trigm , trign , trigwk )
!
!  bwI(1:Ntz) = ( ijreal(1:Ntz) * jireal(1:Ntz) + ijimag(1:Ntz) * jiimag(1:Ntz) )

! note that bwI = \bar I is passed through global and is Fourier decomposed in cb00aa;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! nothing below is required; dMdl is now obsolete; see cb00aa;

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

  RETURN(sw02aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  ofmn(1:mn)=zero ; cfmn(1:mn)=zero
!  call invfft( mn , im , in , Rbc(ll,0,1:mn) , ofmn(1:mn) , cfmn(1:mn) , Zbs(ll,0,1:mn) , Nt , Nz , ijreal(1:Ntz) , ijimag(1:Ntz) , isr , trigm , trign , trigwk )
!
!  do kk = 0,Nz-1 ; zz = kk * pi2nfp / Nz
!   do jj = 0,Nt-1 ; tt = jj * pi2 / Nt ; jk = 1 + jj + kk*Nt
!
!    tb = atan2( ijimag(jk) - Za(jk) , ijreal(jk) - Ra(jk) )
!
!    if( tb.lt.zero ) tb = tb+pi2
!
!    swI(jk) = tt - tb
!
!   enddo
!  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  ALLOCATE(dRmndl,(1:mn,1:mn))
!  ALLOCATE(dZmndl,(1:mn,1:mn))

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

! ijreal = R_\t ; ijimag = Z_t ; WHY IS THIS RECOMPUTED?? ijreal & ijimag have not changed;
!  efmn(1:mn) = zero ; ofmn(1:mn) = -im(1:mn)*Rbc(ll,0,1:mn) ; cfmn(1:mn)= im(1:mn)*Zbs(ll,0,1:mn) ; sfmn(1:mn) = zero
!  call invfft( mn , im(1:mn) , in(1:mn) , efmn(1:mn) , ofmn(1:mn) , cfmn(1:mn) , sfmn(1:mn) , Nt , Nz , ijreal(1:Ntz) , ijimag(1:Ntz) , isr , trigm , trign , trigwk )

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!  do jmn = 1,mn ! harmonics of stream function;
!   
!   if( im(jmn).eq.0 ) cycle ! the m=0 harmonics just change the location of the \theta=0 line toroidally and do not affect spectral width; need to check this;
!   
!   efmn(1:mn) = zero ; ofmn(1:mn) = zero ; cfmn(1:mn)= zero ; sfmn(1:mn) = zero
!   
!   ofmn(jmn) = one ; sfmn(jmn) = one ! transform sine harmonic to real space to implement convolution;
!   call invfft( mn , im(1:mn) , in(1:mn) , efmn(1:mn) , ofmn(1:mn) , cfmn(1:mn) , sfmn(1:mn) , Nt , Nz , jireal(1:Ntz) , jiimag(1:Ntz) , isr , trigm , trign , trigwk )
!   
!   jireal(1:Ntz) = ijreal(1:Ntz) * jireal(1:Ntz) ! R_t * sin( m_k \theta - n_k \zeta ); even;
!   jiimag(1:Ntz) = ijimag(1:Ntz) * jiimag(1:Ntz) ! Z_t * sin( m_k \theta - n_k \zeta );  odd;
!   
!   call tfft( Nt,Nz,jireal(1:Ntz),jiimag(1:Ntz),isr,trigm,trign,trigwk,mn,im(1:mn),in(1:mn),dRmndl(1:mn,jmn),ofmn(1:mn),cfmn(1:mn),dZmndl(1:mn,jmn),ifail )
!   
!  enddo
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
!  dMdl(1:mn) = zero ! this is global;
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  do jmn = 2,mn ! loop over non-trivial lambda harmonics;
!   
!   if( im(jmn).eq.0 ) then ! add constraint of location of \theta=0 toroidal curve;
!    
!    FATAL(sw02aa,jmn-1.gt.Ntor)
!    
!    dMdl(jmn) = zero ! Zbs(ll,0,jmn) - Zam(jmn) ! construct function to set \theta=0 curve to be level with coordinate axis;
!    
!   else
!    
!    do kmn = 1,mn
!     
!     if( im(kmn).eq.0 ) cycle ! spectral width does not depend on m=0 harmonics of coordinate harmonics;
!     
!     mp = im(kmn)**pwidth
!     
!     dMdl(jmn) = dMdl(jmn) + mp * ( Rbc(ll,0,kmn) * dRmndl(kmn,jmn) + Zbs(ll,0,kmn) * dZmndl(kmn,jmn) )
!     
!    enddo ! end of do kmn = 1,mn
!    
!   endif ! end of if( im(jmn).eq.0 )
!   
!  enddo ! end of do jmn = 2,mn
  
!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  do imn = 1,mn
!   if( im(imn).eq.0 .and. abs(dMdl(imn)).gt.vsmall ) then 
!    FATAL(sw02aa : error with dMdl for m=0,.true.)
!   endif
!  enddo

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  DEALLOCATE(dRmndl)
!  DEALLOCATE(dZmndl)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!  RETURN(sw02aa)

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
  
end subroutine sw02aa

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

!latex \item For \verb+pwidth+$=2$, the spectral minimizing angle should be the equal arc angle \cite{Hirshman_Breslau_98}.

!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!

